function Admin(){

}

Admin.prototype.rollBack = function() {
	this.update();
};

Admin.prototype.update = function() {
	kbox.showChange();
	if (!kbox.routerinfo)
		return;
	this.__checkForGOD();
	this.__Rsyslog();
	this.__OverwriteYealinkOption();
	this.__info();
	this.__getGroup();
};

Admin.prototype.onEvent = function() {
	$("body").off();
	var me = this;
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "rsyslog_enable":
				kbox.new_routercfg.rsyslog_enable = !kbox.new_routercfg.rsyslog_enable;
				break;
			case "overwrite_yealink_option":
				kbox.new_routercfg.overwrite_yealink_option = !kbox.new_routercfg.overwrite_yealink_option;
				break;
		}

		if (event.target.id == "socat-src-port" || event.target.id == "socat-dst-ip" || event.target.id == "socat-dst-port") {
			me.__checkSocat();
			return;
		}

		if (event.target.id == "select-update-group")
			return;

		if (elem.hasClass("select-change"))
			kbox.new_routercfg[event.target.id] = event.target.value;
		else if (elem.hasClass("input-change"))
			kbox.new_routercfg[elem.attr('id')] = elem.val();
		me.update();
	});

	$("body").on("click", function(event){
		switch(event.target.id){
			case "btn-up":
				$("#collapseOne").collapse("hide");
				break;
			case "btn-down":
				$("#collapseOne").collapse("show");
				break;
			case "btn-log":
				kbox.getLog();
				break;
			case "btn-arp-table":
				kbox.getArp();
				break;
			case "run-speedtest-dl":
				kbox.speedtestDownload();
				break;
			case "run-speedtest-ul":
				kbox.speedtestUpload();
				break;
			case "run-upgrade-kbox":
				kbox.upgrade();
				break;
			case "run-upgrade-packages":
				kbox.upgradePackages();
				break;
			case "btn-phone-log":
				kbox.getCallLog();
				break;
			case "btn-upgrade-packages":
				kbox.getPackagesList()
				break;
			case "run-hw-reset":
				kbox.hwReset()
				break;
			case "run-socat":
				me.__socat();
				break;
			case "run-update-group":
				me.__updateGroup();
				break;
			case "run-provisioning":
				kbox.provisioning();
				break;
		}
	})
};

Admin.prototype.updatePing = function() {
	
};

Admin.prototype.__checkForGOD = function() {
	if ((kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850")) {
		$("#div_network_infos").hide();
		$("#div_bank").removeClass("toHide");
		this.__infoBank();
		$("#div-phone-elcon").removeClass("toHide");
		$("#main-speedtest-dl").addClass("toHide");
	}

	if(kbox.routercfg.model === "mini-itx") {
		$("#div_network_infos").hide();
		$("#main-hw-reset").hide();
		$("#div-upgrade").hide();
		$("#main-upgrade-packages").removeClass("toHide");
		$("#main-speedtest-ul").removeClass("toHide");
	}

	if (((kbox.routercfg.model == "v1") && (kbox.routercfg.firmware_version < "11.1")) ||
	((kbox.routercfg.model == "v2") && (kbox.routercfg.firmware_version < "12")) ||
	((kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850")))
		$("#run-upgrade-kbox").prop("disabled", false);

	if((kbox.routercfg.firmware_version < "11" && kbox.routercfg.model == "v2") || (kbox.routercfg.model == "v1") || (kbox.routercfg.model === "i4600" || kbox.routercfg.model === "i4850") || kbox.routercfg.dmz_enable)
		$("#main-socat").hide();
};

Admin.prototype.__Rsyslog = function() {
	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850"))
		$("#div-rsyslog").removeClass("toHide");

	if(kbox.new_routercfg.rsyslog_enable) {
		$("#rsyslog_enable").prop("checked", true);
		$("#tr_rsyslog").removeClass("toHide");
		$('#rsyslog_level option[value="'+kbox.new_routercfg.rsyslog_level+'"]').prop('selected', true);
	} else {
		$("#rsyslog_enable").prop("checked",false);
		$("#tr_rsyslog").addClass("toHide");
	}
};

Admin.prototype.__OverwriteYealinkOption = function() {
	if(kbox.new_routercfg.overwrite_yealink_option) {
		$("#overwrite_yealink_option").prop("checked", true);
		$("#tr_over_yoptions").removeClass("toHide");
		$("#overwrite_yealink_option_value").val(kbox.new_routercfg.overwrite_yealink_option_value);
	} else {
		$("#overwrite_yealink_option").prop("checked",false);
		$("#tr_over_yoptions").addClass("toHide");
	}
};

Admin.prototype.__socat = function() {
	var src_port = $("#socat-src-port").val();
	var dst_ip = $("#socat-dst-ip").val();
	var dst_port = $("#socat-dst-port").val();

	kbox.socat(src_port, dst_ip, dst_port);
};

Admin.prototype.__getGroup = function() {
	if ((!kbox.routercfg.is_kosc) && (kbox.routercfg.model != "mini-itx")) {
		$("#div-update-group").removeClass("toHide");
		kbox.getGroup();
	}
};

Admin.prototype.__updateGroup = function() {
	var group = $("#select-update-group option:selected").val();
	kbox.updateGroup(group);
};

Admin.prototype.__checkSocat = function() {
	this.__checkPort($("#socat-src-port"));
	kbox.Check.checkipv4($("#socat-dst-ip"))
	this.__checkPort($("#socat-dst-port"));

	if (($("#socat-dst-port").parent().hasClass("has-success")) && ($("#socat-dst-ip").parent().hasClass("has-success")) && ($("#socat-src-port").parent().hasClass("has-success")))
		$("#run-socat").prop("disabled", false);
	else
		$("#run-socat").prop("disabled", true);
};

Admin.prototype.__info = function() {
	var client_name = (kbox.routercfg.client_name?kbox.routercfg.client_name:"-");
	var client_society = ((kbox.routercfg.client_society && kbox.routercfg.client_society != 'None')?kbox.routercfg.client_society:"-");
	var client_id_split = kbox.routercfg.client_id.split("-")[0];
	
	$("#info-lan-mac").text(kbox.routerinfo.lan_mac);
	$("#info-wan-mac").text(kbox.routerinfo.wan_mac);
	$("#info-wifi-mac").text(kbox.routerinfo.wifi_mac);
	$("#client_id").text(kbox.routercfg.client_id);
	$("#client_name").text(client_name);
	$("#client_society").text(client_society);
	if(kbox.routercfg.company === "KSYS") {
		$("#client_si_link").attr("href", "https://admin-ksys.k-sys.ch/admin/clients/show/id/" + client_id_split)
	} else {
		if (kbox.sub_id)
			$("#client_si_link").attr("href", "https://cocktail.caps.services/cc/" + client_id_split + "/details")
		else
			$("#client_si_link").attr("href", "https://si.k-net.fr/admin/clients/show/id/" + client_id_split)
	}
};

Admin.prototype.__checkPort = function(elem) {
        if (elem.val() == "") {
                elem.parent().removeClass("has-error");
                elem.parent().removeClass("has-success");
        }
        else if (kbox.Check.checkport(elem)) {
                elem.parent().removeClass("has-error");
                elem.parent().addClass("has-success");
        }
        else {
                elem.parent().removeClass("has-success");
                elem.parent().addClass("has-error");
        }
};

Admin.prototype.__infoBank = function() {
	for (var i = 1; i < 3; i++) {
		var version = (kbox.routerinfo.bank[i].version?kbox.routerinfo.bank[i].version:"-");
		var booting = (kbox.routerinfo.bank[i].booting?kbox.routerinfo.bank[i].booting:"-").replace('primary', 'premier').replace('secondary', 'deuxième');
		if (kbox.routerinfo.bank[i].status) {
			if (kbox.routerinfo.bank[i].status == 'ok')
				$("#bank" + i + "_status").addClass('glyphicon-ok')
			else if (kbox.routerinfo.bank[i].status == 'corrupted')
				$("#bank" + i + "_status").addClass('glyphicon-remove')
			else
				$("#bank" + i + "_status").addClass('glyphicon-question-sign')
		} else {
			$("#bank" + i + "_booting").text('-')
		}

		$("#bank" + i + "_version").text(version);
		$("#bank" + i + "_booting").text(booting);
	}
};
