function Advanced(){

}

Advanced.prototype.rollBack = function() {
	this.update();
};

Advanced.prototype.update = function() {
	if (((kbox.routercfg.model == "v1") && (kbox.routercfg.firmware_version >= "11") ||
		(kbox.routercfg.model == "v2") || (kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850")) && (kbox.routercfg.display_v6))
		$("#v2-ipv6").removeClass("toHide");
	if((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
		$("#div-leds").removeClass("toHide");
		$("#div-nat").removeClass("toHide");
		$("#snmp_icotera").removeClass("toHide");
		if (!$.cmpIcoteraFirm(kbox.routercfg.firmware_version, "16.0"))
			$("#rule-source-ip").prop("disabled", true);
		this.__FIREWALL_V6();
		kbox.getLANIPv6();
	}
	if (kbox.routercfg.model == "mini-itx") {
		this.__BRIDGE();
		$("#vlan").removeClass("toHide");
	}

	$('#dnsv6-content').text('Utiliser les serveurs DNS IPv6 ' + (!kbox.routercfg.company?'de votre FAI':kbox.routercfg.company));
	$('#leds_brightness option[value="'+kbox.new_routercfg.leds_brightness+'"]').prop('selected', true);
	$('#nat_type option[value="'+kbox.new_routercfg.nat_type+'"]').prop('selected', true);
	
	$("#popup-loading").hide();
	kbox.showChange();

	this.__IPV6();
	this.__FORWARD();
	this.__SNMPInfos();
	this.__DMZ();

	if (kbox.routerinfo)
		kbox.getLANMac(kbox.routerinfo["list_dune"]);
	kbox.getLANIp();
};

Advanced.prototype.updateEvent = function() {
	var me = this;

	$(".host-item-ip").off();
	$(".host-item-ip").click(function() {
		if($(this).parent().parent().parent().attr('id')) {
			$("#dmz_ip").val($(this).text().split(" (")[0]);
      		kbox.Check.checkipv4($("#dmz_ip"));
      		me.__updateInput($("#dmz_ip"));
      		me.update();
		} else {
			$("#rule-dest-ip").val($(this).text().split(" (")[0]);
      		kbox.Check.checkipv4($("#rule-dest-ip"));
      	}
	});

	$(".host-item-ipv6").off();
	$(".host-item-ipv6").click(function() {
		$("#firewall-v6-dst-ip").val($(this).text().split(" (")[0]);
		kbox.Check.checkipv6($("#firewall-v6-dst-ip"));
	});
};

Advanced.prototype.onEvent = function() {
	var me = this;
	$("body").off();
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "enable_ipv6":
				kbox.new_routercfg.enable_ipv6 = !kbox.new_routercfg.enable_ipv6;
				break;
			case "get_kwaoo_dnsv6":
				kbox.new_routercfg.get_kwaoo_dnsv6 = !kbox.new_routercfg.get_kwaoo_dnsv6;
				break;
			case "snmp_enable":
				kbox.new_routercfg.snmp_enable = !kbox.new_routercfg.snmp_enable;
				break;
			case "dmz_enable":
				me.__updateDMZ();
				break;
			case "firewall_v6_enable":
				kbox.new_routercfg.firewall_v6_enable = !kbox.new_routercfg.firewall_v6_enable;
				break;
			/* Redicrections */
			case "rule-source-ip":
				me.__checkSourceIP(elem);
				break;
			case "rule-dest-ip":
				kbox.Check.checkipv4(elem);
				break;
			case "firewall-v6-src-ip":
				kbox.Check.checkipv6(elem);
				break;
			case "firewall-v6-dst-ip":
				kbox.Check.checkipv6(elem);
				break;
		}

		if (elem.hasClass("input-change"))
			me.__updateInput(elem);
		else if (elem.hasClass("port-check"))
			me.__checkPort(elem);
		else if (elem.hasClass("vlan-id-check"))
			me.__checkVlanID(elem);
		else if (event.target.id == "rule-name" || event.target.id == "rule-source-ip" ||
			event.target.id == "rule-dest-ip" || event.target.id == "rule-source-port" ||
			event.target.id == "rule-dest-port" || event.target.id == "bridge-s-vlan-id" ||
			event.target.id == "bridge-c-vlan-id" || event.target.id == "firewall-v6-desc" ||
			event.target.id == "firewall-v6-proto" || event.target.id == "firewall-v6-dst-port" ||
			event.target.id == "firewall-v6-dst-ip" || event.target.id == "firewall-v6-src-ip")
			return;
		else if (elem.hasClass("select-change"))
			kbox.new_routercfg[event.target.id] = event.target.value;

		me.update();
	});

	$("body").on("click", function(event){
		var elem = $("#"+event.target.id);
		if (event.target.id == "btn-add-portforward-rule"){
			me.__addFormwardRule();
			if ((!$("#rule-name").parent().hasClass("has-error")) || (!$("#rule-source-port").parent().hasClass("has-error"))) {
				me.update();
			}
		}

		if (event.target.id == "btn-add-bridge"){
			me.__addBridgeRule();
			if ((!$("#bridge-desc").parent().hasClass("has-error")) && (!$("#bridge-vlan-id").parent().hasClass("has-error")) &&
				(!$("#bridge-c-vlan-id").parent().hasClass("has-error"))) {
				me.update();
			}
		}

		if (event.target.id == "btn-add-firewall-v6-rule"){
			me.__addFirewallv6Rule();
			me.update();
		}

		if (typeof $(event.target).data('original-title') == 'undefined' && !$(event.target).parents().is('.popover.in')) {
   	 		$('[data-original-title]').popover('hide');
  		}
		
	});
};

Advanced.prototype.__updateInput = function(elem) {
	if (elem.attr('id') == "input-6dns1")
		kbox.new_routercfg.ipv6_dns_1 = $("#input-6dns1").val();
	else if (elem.attr('id') == "input-6dns2")
        kbox.new_routercfg.ipv6_dns_2 = $("#input-6dns2").val();
    else
    	kbox.new_routercfg[elem.attr("id")] = elem.val();

    if (elem.attr('id') == "dmz_ip") {
    	var res = kbox.Check.checkipv4(elem)
        if (elem.val() == "")
        	kbox.new_routercfg.dmz_enable = false;
        else if (res)
        	kbox.new_routercfg.dmz_enable = true;
    }
};

Advanced.prototype.__updateDMZ = function() {
	if ((kbox.Check.checkipv4($("#dmz_ip")) &&
	kbox.new_routercfg.dmz_enable == false) ||
	(kbox.new_routercfg.dmz_enable == true)) {
		kbox.new_routercfg.dmz_enable = !kbox.new_routercfg.dmz_enable;
    }
};

Advanced.prototype.__checkPort = function(elem) {
	if (elem.val() == "") {
		elem.parent().removeClass("has-error");
		elem.parent().removeClass("has-success");
	}
	else if (kbox.Check.checkport(elem)) {
		elem.parent().removeClass("has-error");
		elem.parent().addClass("has-success");
	}
	else {
		elem.parent().removeClass("has-success");
		elem.parent().addClass("has-error");
	}
};

Advanced.prototype.__checkVlanID = function(elem) {
	if (elem.val() == "") {
		elem.parent().removeClass("has-error");
		elem.parent().removeClass("has-success");
	}
	else if (kbox.Check.checkvlanid(elem)) {
		elem.parent().removeClass("has-error");
		elem.parent().addClass("has-success");
	}
	else {
		elem.parent().removeClass("has-success");
		elem.parent().addClass("has-error");
	}
};

Advanced.prototype.__checkSourceIP = function(elem) {
	var ip = elem.val();
	if (ip == "*") // on TRICHE!
  		elem.val('0.0.0.0');
	var okay = ((kbox.Check.checksubnet(elem)) || (kbox.Check.checkrangeip(elem)) || (kbox.Check.checklistip(elem)));
  	elem.val(ip);
	if (elem.val() == "") {
    	elem.parent().removeClass("has-error");
    	elem.parent().removeClass("has-success");
    }
    else if (okay) {
    	elem.parent().removeClass("has-error");
    	elem.parent().addClass("has-success");
    }
    else {
    	elem.parent().removeClass("has-success");
    	elem.parent().addClass("has-error");
    }
};

Advanced.prototype.__addFormwardRule = function() {
	$("#rule-name").parent().removeClass("has-error");
	$("#rule-source-port").parent().removeClass("has-error");
	var name = $("#rule-name").val();
    var proto = $("#rule-proto").val();
    var src_ip = $("#rule-source-ip").val();
    var src_port = $("#rule-source-port").val();
    var dest_ip = $("#rule-dest-ip").val();
    var dest_port = $("#rule-dest-port").val();
    var active = $("#rule-active").is(':checked');

    if (name == "" || src_port == "" || dest_ip == "")
        return;

    if (src_ip == "*")
		src_ip = "";
    if (!kbox.Check.checkport($("#rule-dest-port")) &&
        !kbox.Check.checkport($("#rule-source-port")) &&
        !kbox.Check.checkipv4($("#rule-dest-ip")) &&
	(!((kbox.Check.checksubnet($("#rule-source-ip"))) || (kbox.Check.checkrangeip($("#rule-source-ip"))) || (kbox.Check.checklistip($("#rule-source-ip")))) && $("#rule-source-ip").val() != ""))
      return;

  	if (!kbox.Check.check_sensitive_port($("#rule-source-port"))) {
		$("#sens_port").html("(<b>"+src_port+"</b>)");
		$("#pf-sens-alert").removeClass("toHide");
	}

	nbRules = 0;
  	for(var pos in kbox.new_routercfg.portforward){
		if (kbox.new_routercfg.portforward[pos].proto == "3")
			nbRules += 2;
		else
			nbRules += 1;
  		if (name == kbox.new_routercfg.portforward[pos].description){
  			$("#rule-name").parent().addClass("has-error");
  			return;
  		}
		if ((proto == kbox.new_routercfg.portforward[pos].proto) && (src_port == kbox.new_routercfg.portforward[pos].ext_port) && (active == kbox.new_routercfg.portforward[pos].active) && (active)){
			$("#rule-source-port").parent().addClass("has-error");
			return;
		}
  	}

    name = name.replace(/>/g, '&gt;').replace(/</g, '&lt;');
    $("#rule-name").val("");
    $("#rule-source-ip").val("");
    $("#rule-source-port").val("");
    $("#rule-dest-ip").val("");
    $("#rule-dest-port").val("");

    if (((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) && (proto == "3") && (nbRules >= 126)) {
	$("#alert-server-error").parent().show();
	$("#alert-server-error").html("<strong>Erreur !</strong> Le nombre d'ouvertures de ports est limité à 128 sur les Icotera.");
	setTimeout(function(){
		$("#alert-server-error").parent().hide();
	}, 7000);
	return;
    }

    kbox.add_port_rule(name, proto, src_ip, src_port,
      dest_ip, dest_port, active);
};

Advanced.prototype.removeRule = function(id, type) {
	if (type == 'pf')
		var rule = kbox.new_routercfg.portforward;
	else if (type == 'firewall-v6')
		var rule = kbox.new_routercfg.firewall_v6;
	else
		var rule = kbox.new_routercfg.bridge;
	if (rule[id])
		rule.splice(id,1);
	this.update();
};

Advanced.prototype.switchStateRule = function(id, elem, type) {
	var rule = (type=='pf'?kbox.new_routercfg.portforward:kbox.new_routercfg.bridge);
	rule[id].active = !rule[id].active;
	if (!rule[id].active)
		elem.removeClass("off");
	else
		elem.addClass("off");
	this.update();
};

Advanced.prototype.__IPV6 = function() {
	if (kbox.new_routercfg.enable_ipv6){
		$("#enable_ipv6").prop("checked", true);
		if ((kbox.routercfg.model != "i4600") && (kbox.routercfg.model != "i4850")) {
			$("#dnsv6").show();
			if (kbox.new_routercfg.get_kwaoo_dnsv6){
				$("#get_kwaoo_dnsv6").prop("checked", true);
				$("#dnsv6-detail").hide();
			}
			else{
				$("#get_kwaoo_dnsv6").prop("checked", false);
				$("#dnsv6-detail").show();
				//////////////////////////
				if ((kbox.new_routercfg.ipv6_dns_1) && (kbox.new_routercfg.ipv6_dns_2)){
					$("#input-6dns1").val(kbox.new_routercfg.ipv6_dns_1);
					$("#input-6dns2").val(kbox.new_routercfg.ipv6_dns_2);
				}
			}
		}

		if((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
			if ($.cmpIcoteraFirm(kbox.routercfg.firmware_version, "16.3")) {
				$("#firewall_v6_enable_content").show();
				if (kbox.new_routercfg.firewall_v6_enable){
					$("#firewall_v6_enable").prop("checked", true);
					$("#firewall_v6_content").show();
				} else {
					$("#firewall_v6_enable").prop("checked", false);
					$("#firewall_v6_content").hide();
				}
			}
		}
	}else{
		$("#enable_ipv6").prop("checked", false);
		$("#dnsv6").hide();
		$("#dnsv6-detail").hide();
		$("#firewall_v6_enable_content").hide();
		$("#firewall_v6_content").hide();
	}	
};

Advanced.prototype.__SNMPInfos = function() {
	if (kbox.new_routercfg.snmp_enable == true) {
		$("#snmp_enable").prop("checked", true);
		$("#snmp_infos").prop("disabled", false);
	} else {
		$("#snmp_enable").prop("checked", false);
		$("#snmp_infos").prop("disabled", true);
	}

	var infosSNMP = '<table class="table table-bordered table-center"><tr><th>Communauté publique: </th><td class="font-password">'+(kbox.new_routercfg.snmp_password ? kbox.new_routercfg.snmp_password : 'Inconnue')+'</td></tr></table>'
	$("#snmp_infos").attr("data-content", infosSNMP);
};


Advanced.prototype.__DMZ = function() {
	if (((kbox.new_routercfg.enable_lan_dhcpd == false) || (kbox.routercfg.is_kosc)) && ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")))
		$("#dmz").hide();
	else
		$("#dmz").show();

	if (kbox.new_routercfg.dmz_enable == true) {
		$("#dmz_enable").prop("checked", true);
		$("#dmz_ip").val(kbox.new_routercfg.dmz_ip);
	} else {
		$("#dmz_enable").prop("checked", false);
		$("#dmz_ip").val(kbox.new_routercfg.dmz_ip);
	}
};

Advanced.prototype.__FORWARD = function() {
	var lr = kbox.new_routercfg.portforward;
	var nbRules = 0;
	$('.portforward-rule').remove();
	for (var rule in lr) {
		htmlactive = "";
		off = ""
		if (lr[rule].active == "1")
			htmlactive = 'checked="checked"';
		else
			off = "off"
		if (lr[rule].proto == "3")
			nbRules += 2
		else
			nbRules += 1
		$('#tr-add-rule-port').before(
			$('<tr id="'+rule+'" class="portforward-rule '+off+'"><td>'+lr[rule].description+
				'</td><td>'+$.prototxt(lr[rule].proto+'')+
				'</td><td>'+$.wild(lr[rule].src_ip)+'</td><td>'+$.wild(lr[rule].ext_port)+
				'</td><td>'+$.wild(lr[rule].int_ip)+'</td><td>'+(lr[rule].int_port == "" || lr[rule].int_port == undefined ? lr[rule].ext_port : lr[rule].int_port)+
				'</td><td><input class="check-rule" type="checkbox" '+htmlactive+' onclick="javascript:instance.switchStateRule(\''+rule+'\', $(this), \'pf\');"/>'+
				'</td><td><button class="btn-rule-del" style="width:10px;height:10px;" type="button"'+
				' onclick="javascript:instance.removeRule(\''+rule+'\', \'pf\');"><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
		);
	}

	if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
		if (nbRules >= 127)
			$("#tr-add-rule-port").addClass("toHide");
		else
			$("#tr-add-rule-port").removeClass("toHide");
	}
};

Advanced.prototype.__BRIDGE = function() {
	var br = kbox.new_routercfg.bridge;
	$('.bridge-rule').remove();
	for (var rule in br) {
		htmlactive = "";
		off = ""
		if (br[rule].active == "1")
			htmlactive = 'checked="checked"';
		else
			off = "off"

		$('#tr-add-bridge').before(
			$('<tr id="'+rule+'" class="bridge-rule '+off+'">'+
				'<td>'+br[rule].description+'</td>'+
				'<td>'+br[rule].s_vlan_id+'</td>'+
				'<td>'+$.wild(br[rule].c_vlan_id)+'</td>'+
				'<td>'+$("#bridge-wan option[value='"+br[rule].wan+"']").text()+'</td>'+
				'<td>'+$("#bridge-lan1 option[value='"+br[rule].lan1+"']").text()+'</td>'+
				'<td>'+$("#bridge-lan2 option[value='"+br[rule].lan2+"']").text()+'</td>'+
				'<td>'+$("#bridge-lan3 option[value='"+br[rule].lan3+"']").text()+'</td>'+
				'<td><input class="check-rule" type="checkbox" '+htmlactive+' onclick="javascript:instance.switchStateRule(\''+rule+'\', $(this), \'bridge\');"/></td>'+
				'<td><button class="btn-rule-del" style="width:10px;height:10px;" type="button"'+
				' onclick="javascript:instance.removeRule(\''+rule+'\', \'bridge\');"><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
		);
	}
};

Advanced.prototype.__addBridgeRule = function() {
	$("#bridge-desc").parent().removeClass("has-error");
	$("#bridge-s-vlan-id").parent().removeClass("has-error");
	$("#bridge-c-vlan-id").parent().removeClass("has-error");

	var desc = $("#bridge-desc").val();
    var s_vlan_id = $("#bridge-s-vlan-id").val();
    var c_vlan_id = $("#bridge-c-vlan-id").val();
    var wan = $("#bridge-wan").val();
    var lan1 = $("#bridge-lan1").val();
    var lan2 = $("#bridge-lan2").val();
    var lan3 = $("#bridge-lan3").val();
    var active = $("#bridge-active").is(':checked');

    if (desc == "" || s_vlan_id == "" || (!kbox.Check.checkvlanid($("#bridge-s-vlan-id"))) ||
       ((c_vlan_id != "") && (!kbox.Check.checkvlanid($("#bridge-c-vlan-id")))) || (!this.__checkBridgePort()))
        return;

	for(var pos in kbox.new_routercfg.bridge){
		if (desc == kbox.new_routercfg.bridge[pos].description){
			$("#bridge-desc").parent().addClass("has-error");
			return;
		}

		if ((s_vlan_id == kbox.new_routercfg.bridge[pos].s_vlan_id) && (c_vlan_id == "")) {
			$("#bridge-s-vlan-id").parent().addClass("has-error");
			return;
		}

		if ((s_vlan_id == kbox.new_routercfg.bridge[pos].s_vlan_id) && (c_vlan_id == kbox.new_routercfg.bridge[pos].c_vlan_id)) {
			$("#bridge-c-vlan-id").parent().addClass("has-error");
			return;
		}
	}

    desc = desc.replace(/>/g, '&gt;').replace(/</g, '&lt;');
    $("#bridge-desc").val("");
    $("#bridge-s-vlan-id").val("");
    $("#bridge-c-vlan-id").val("");
    $("#bridge-wan").val("not member");
    $("#bridge-lan1").val("not member");
    $("#bridge-lan2").val("not member");
    $("#bridge-lan3").val("not member");
    kbox.add_bridge_rule(desc, s_vlan_id, c_vlan_id, wan, lan1, lan2, lan3, active);
};

Advanced.prototype.__checkBridgePort = function() {
	if((($("#bridge-wan").val() == "not member" ? 1 : 0) +
	($("#bridge-lan1").val() == "not member" ? 1 : 0) +
	($("#bridge-lan2").val() == "not member" ? 1 : 0) +
	($("#bridge-lan3").val() == "not member" ? 1 : 0)) >= 3)
		return false;
	return true;
};

Advanced.prototype.__FIREWALL_V6 = function() {
	var firewall_v6 = kbox.new_routercfg.firewall_v6;
	var nbRules = 0;
	$('.firewall-v6-rule').remove();
	for (var rule in firewall_v6) {
		htmlactive = "";
		off = ""
		nbRules += 1
		if (firewall_v6[rule].active == "1")
			htmlactive = 'checked="checked"';
		else
			off = "off"

		$('#tr-add-firewall-v6').before(
			$('<tr id="'+rule+'" class="firewall-v6-rule '+off+'"><td>'+firewall_v6[rule].description+
				'</td><td>'+firewall_v6[rule].proto+
				'</td><td>'+$.wild(firewall_v6[rule].src_ip)+'</td>'+
				'</td><td>'+$.wild(firewall_v6[rule].dst_ip)+'</td>'+
				'</td><td>'+$.wild(firewall_v6[rule].dst_port)+'</td>'+
				'</td><td><input class="check-rule" type="checkbox" '+htmlactive+' onclick="javascript:instance.switchStateRule(\''+rule+'\', $(this), \'firewall-v6\');"/>'+
				'</td><td><button class="btn-rule-del" style="width:10px;height:10px;" type="button"'+
				' onclick="javascript:instance.removeRule(\''+rule+'\', \'firewall-v6\');"><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
		);
	}

	if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
		if (nbRules >= 32)
			$("#tr-add-firewall-v6").addClass("toHide");
		else
			$("#tr-add-firewall-v6").removeClass("toHide");
        }
};

Advanced.prototype.__addFirewallv6Rule = function() {
	$("#firewall-v6-desc").parent().removeClass("has-error");

	var desc = $("#firewall-v6-desc").val();
	var proto = $("#firewall-v6-proto").val();
	var src_ip = $("#firewall-v6-src-ip").val();
	var dst_ip = $("#firewall-v6-dst-ip").val();
	var dst_port = $("#firewall-v6-dst-port").val();
	var active = $("#firewall-v6-active").is(':checked');

	if (desc == "" || dst_ip == "" || dst_port == "")
		return;

	if (src_ip == "*")
		src_ip = "";

	if (!kbox.Check.checkport($("#firewall-v6-dst-port")) ||
	    ((src_ip != "") && ((!kbox.Check.checkipv6($("#firewall-v6-src-ip"))) || (!kbox.Check.checksubnetv6($("#firewall-v6-src-ip"))))) ||
	    ((!kbox.Check.checkipv6($("#firewall-v6-dst-ip"))) || (!kbox.Check.checksubnetv6($("#firewall-v6-dst-ip")))))
		return;

	nbRules = 0;
	for(var pos in kbox.new_routercfg.firewall_v6){
		nbRules += 1;
                if (name == kbox.new_routercfg.firewall_v6[pos].description){
			$("#firewall-v6-desc").parent().addClass("has-error");
                        return;
                }
        }

	desc = desc.replace(/>/g, '&gt;').replace(/</g, '&lt;');
	$("#firewall-v6-desc").val("");
	$("#firewall-v6-src-ip").val("");
	$("#firewall-v6-dst-ip").val("");
	$("#firewall-v6-dst-port").val("");

	kbox.add_firewall_v6_rule(desc, proto, src_ip, dst_ip, dst_port, active);
};
