function Check() {

}

Check.prototype.checktype = function(e){
	if (e.hasClass('ip-input'))
		return this.checkipv4(e);
	if (e.hasClass('subnet-input'))
		return this.checksubnet(e);
	if (e.hasClass('ipv6-input'))
		return this.checkipv6(e);
	if (e.hasClass("int-input"))
		return this.checkint(e);
	if (e.hasClass("mac-input"))
		return this.checkmac(e);
	if (e.hasClass("ssid-input"))
		return this.checkssid(e);
	if (e.hasClass("password-input"))
		return this.checkpassword(e);
	if (e.hasClass("world-input"))
		return this.checkworld(e);
	if (e.hasClass("phone-input"))
		return this.checkphone(e);
}

Check.prototype.checkphone = function(e){
	var phone = /^[0-9]{10}$/;
	return this.__check(e, phone);
}

Check.prototype.checkworld = function(e){
	var world = /^[\x00-\x7F]+$/;
	return this.__check(e, world);
}

Check.prototype.checkssid = function(e) {
	var ssid = /^[\x00-\x7F]{4,27}$/;
	return this.__check(e, ssid);
}

Check.prototype.checkpassword = function(e) {
	var pwd = /^[\x00-\x7F]{8,64}$/;
	return this.__check(e, pwd);
}

Check.prototype.checkmac = function(e) {
    var mac_with_colons = /^(([0-9A-Fa-f]{2}:){2}|([0-9A-Fa-f]{2}:){5})[0-9A-Fa-f]{2}$/;
    return this.__check(e, mac_with_colons);
}

Check.prototype.checkipv4 = function(e) {
	var ip = /^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/;
	return this.__check(e, ip);
}

Check.prototype.checksubnet = function(e) {
	var subnet = /^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/([0-9]|1[0-9]|2[0-9]|3[0-2]))?$/;
	return this.__check(e, subnet);
}

Check.prototype.checkipv6 = function(e){
	// WTF is this:
	var ip = /(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,5}(:[0-9a-fA-F]{1,4}){1,2}|([0-9a-fA-F]{1,4}:){1,4}(:[0-9a-fA-F]{1,4}){1,3}|([0-9a-fA-F]{1,4}:){1,3}(:[0-9a-fA-F]{1,4}){1,4}|([0-9a-fA-F]{1,4}:){1,2}(:[0-9a-fA-F]{1,4}){1,5}|[0-9a-fA-F]{1,4}:((:[0-9a-fA-F]{1,4}){1,6})|:((:[0-9a-fA-F]{1,4}){1,7}|:)|fe80:(:[0-9a-fA-F]{0,4}){0,4}%[0-9a-zA-Z]{1,}|::(ffff(:0{1,4}){0,1}:){0,1}((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])|([0-9a-fA-F]{1,4}:){1,4}:((25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9])\.){3,3}(25[0-5]|(2[0-4]|1{0,1}[0-9]){0,1}[0-9]))/;
	return this.__check(e, ip);
}

Check.prototype.checksubnetv6 = function(e){
	// WTF is this:
	var subnet = /^s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]d|1dd|[1-9]?d)(.(25[0-5]|2[0-4]d|1dd|[1-9]?d)){3}))|:)))(%.+)?s*(\/([0-9]|[1-9][0-9]|1[0-1][0-9]|12[0-8]))?$/
	return this.__check(e, subnet);
}

Check.prototype.checkhost = function(e) {
	// This is a damn regex !
   	var host = /^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$|^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$|^(?:(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){6})(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:::(?:(?:(?:[0-9a-fA-F]{1,4})):){5})(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})))?::(?:(?:(?:[0-9a-fA-F]{1,4})):){4})(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){0,1}(?:(?:[0-9a-fA-F]{1,4})))?::(?:(?:(?:[0-9a-fA-F]{1,4})):){3})(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){0,2}(?:(?:[0-9a-fA-F]{1,4})))?::(?:(?:(?:[0-9a-fA-F]{1,4})):){2})(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){0,3}(?:(?:[0-9a-fA-F]{1,4})))?::(?:(?:[0-9a-fA-F]{1,4})):)(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){0,4}(?:(?:[0-9a-fA-F]{1,4})))?::)(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9]))\.){3}(?:(?:25[0-5]|(?:[1-9]|1[0-9]|2[0-4])?[0-9])))))))|(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){0,5}(?:(?:[0-9a-fA-F]{1,4})))?::)(?:(?:[0-9a-fA-F]{1,4})))|(?:(?:(?:(?:(?:(?:[0-9a-fA-F]{1,4})):){0,6}(?:(?:[0-9a-fA-F]{1,4})))?::))))$/;
    return this.__check(e, host);
}

Check.prototype.checkint = function(e) {
	var integer = /^[0-9]+$/;
	return this.__check(e, integer);
}

Check.prototype.checkwep = function(e, size){
	if (e.val().length != size) {
		e.parent().addClass("has-error");
    	e.parent().removeClass("has-success");
    	return false;
	} else {
		var wep = /^[a-zA-Z0-9]+$/;
		return this.__check(e, wep);
	}
}

Check.prototype.checkport = function(e) {
	var val = e.val().replace(/ /g, '');
	var goodport = false;
	if (val.match(/^[0-9]+$/))
		goodport = (val < 65536);
	else {
		var tklist = val.split(',');
		for (var tk in tklist) {
			var vklist = tklist[tk].split(':');
			if (vklist.length == 1) {
				goodport = (tklist[tk].match(/^[0-9]+$/) && tklist[tk] < 65536);
			}
			else if (vklist.length > 2) {
				return false;
			}
			else {
				goodport = (vklist[0].match(/^[0-9]+$/) && vklist[0] < 65536) &&
							(vklist[1].match(/^[0-9]+$/) && vklist[1] < 65536) &&
							parseInt(vklist[0]) < parseInt(vklist[1]);

			}
			if (!goodport) return false;
		}
	}
	return goodport;
}

Check.prototype.check_sensitive_port = function(e) {
	var sens_port = ['53', '5060', '5062']
	var val = e.val().replace(/ /g, '');
	if (val.match(/^[0-9]+$/)) {
		if (sens_port.indexOf(val) > -1) {
			return false;
		}
	} else {
		var tklist = val.split(',');
		for (var tk in tklist) {
			var vklist = tklist[tk].split(':');
			if (vklist.length != 2)
				return false;

			for (var port in sens_port) {
				if ((vklist[0] <= sens_port[port]) && (sens_port[port] <= vklist[1]))
					return false;
			}
		}
	}
	return true;
}

Check.prototype.inet_aton = function(ip) {
	var ipl = ip.split('.');
	return (ipl[0]*256^3)+(ipl[1]*256^2)+(ipl[2]*256^1)+(ipl[3]*256^0);
}

Check.prototype.checkrangeip = function(e) {
	if (e.val() == "")
		return true;
	if (!this.checkipv4(e)) {
		var ipl = e.val().split('-');
		if (ipl.length > 2)
			return false;
		if (ipl[0].match(/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/) &&
			ipl[1].match(/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/))
			return this.inet_aton(ipl[0])-this.inet_aton(ipl[1]) <= 0;
		else
			return false;
	}
	else
		return true;
}

Check.prototype.checklistip = function(e) {
	if (e.val() == "")
		return true;

	var ipl = e.val().split(',');
	for (var ip in ipl) {
		if (!ipl[ip].match(/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/))
			return false;
	}
	return true;
}

Check.prototype.checkvlanid = function(e) {
	if ((e.val() >= 1) && (e.val() <= 4096))
		return true;
	return false;
}

Check.prototype.__check = function(e, regexp) {
	var val = e.val();
    if (val == "") {
    	e.parent().removeClass("has-error");
        e.parent().removeClass("has-success");
        return false;
    }
    else if (val.match(regexp)) {
    	e.parent().removeClass("has-error");
        e.parent().addClass("has-success");
        return true;
    }
    else {
		e.parent().removeClass("has-success");
		e.parent().addClass("has-error");
		return false;
    }
};
