$.urlParam = function(name){
	var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
    try{
    	return results[1] || null;
	}catch(e){
		return null;
	}
}

$.sortobject = function(obj) {
    var keys = [];
    var sorted_obj = {};

    for(var key in obj){
        if(obj.hasOwnProperty(key)){
            keys.push(key);
        }
    }
    keys.sort();
    jQuery.each(keys, function(i, key){
        sorted_obj[key] = obj[key];
    });
    return sorted_obj;
}

var days = {
	'Samedi': 64,
	'Vendredi': 32,
	'Jeudi': 16,
	'Mercredi': 8,
	'Mardi': 4,
	'Lundi': 2,
	'Dimanche': 1
};

$.pclean = function(value) {
	return value == 'none' || value == 'off' || value == '' || value == 'null' ? '-' : value;
}

$.days_to_txt = function(value) {
	var dar = [];
	var r = value;
	for (var d in days) {
		if (r - days[d] >= 0) {
			dar.push(d);
			r -= days[d];
		}
	}
	return dar.reverse().join(', ');
}

$.time_to_html = function(value) {
	var h = Math.floor(value/60);
	var m = value%60;

	function rr(val) {
		if (val < 10)
			return "0"+val;
		return val;
	}
	return rr(h)+":"+rr(m);
}

$.prototxt = function(val) {
	switch(val) {
		case "1":
			return 'TCP';
			break;
		case "2":
			return 'UDP';
			break;
		case "3":
			return 'TCP/UDP';
			break;
	}
}

$.wild = function(val) {
	var res = val;
	if (val == undefined || val == "" || val == "::/0")
		res = "*";
	return res;
}

$.diffobject = function(o1, o2) {
	var diff = {};

   	for (var k in o1) {
      	if (!(k in o2))
        	diff[k] = undefined;  // property gone so explicitly set it undefined
      	else if (o1[k] !== o2[k])
        	diff[k] = o2[k];  // property in both but has changed
   	}

   	for (k in o2) {
      	if (!(k in o1))
         	diff[k] = o2[k]; // property is new
   	}

   	return diff;
}

$.disableElementsByClass = function(myClass) {
	$("." + myClass).prop("disabled", true);
}

$.enableElementsByClass = function(myClass) {
	$("." + myClass).prop("disabled", false);
	$('[data-toggle="tooltip"]').tooltip();
}

$.cmpIcoteraFirm = function(currentFirm, cmpFirm) {
	split_firmware = currentFirm.split('.');
	return (split_firmware[1] + "." + split_firmware[2]) >= cmpFirm;
}
