function Info(){
	this.nic_list_netgear = ['wan', '1', '2', '3', '4'];
	this.nic_list_elcon = ['4', '3', '2', '1', 'wan'];
	this.nic_list_miniitx = ['3', '2', '1', 'wan'];
}

Info.prototype.rollBack = function() {
	kbox.showChange();
};

Info.prototype.update = function() {
	kbox.showChange();
	this.__showSys();
	if (kbox.configStatus >= 400){
		$(".info-oups").show();
		$(".info-extract").hide();
		return;
	}
	if (!kbox.routerinfo)
		return;
	this.__showNetwork();
	this.__showEthPlug();
	this.__showWifi();

	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) {
		$("#div-phone").removeClass("toHide");
		$("#div-ce-elcon").removeClass("toHide");
		$("#div-we-elcon").removeClass("toHide");
		this.__showPhones();
		this.__showUsbPlug();
	} else if ((kbox.new_routercfg.model === "v1") || (kbox.new_routercfg.model === "v2")){
		if ((kbox.routercfg.model == "v2") && (kbox.routercfg.firmware_version >= "11"))
			$("#but-all-equip").removeClass("toHide");
		$("#tr-cpuload").removeClass("toHide");
		$("#tr-memfree").removeClass("toHide");
		$("#div-ce-netgear").removeClass("toHide");
		$("#div-we-netgear").removeClass("toHide");
		this.__showUsbPlug();
	} else {
		$("#div-services").removeClass("toHide");
		this.__showServices();
		$("#tr-cpuload").removeClass("toHide");
		$("#tr-memfree").removeClass("toHide");
		$("#tr1-disk").removeClass("toHide");
		$("#tr2-disk").removeClass("toHide");
		this.__showDiskInfos();
		$("#div-ce-elcon").removeClass("toHide");
		if ((kbox.routercfg.failover_enable) || (kbox.routercfg.failover_4g_enable))
			$("#tr-link-failover").removeClass("toHide");
		else
			$("#tr-link-failover").addClass("toHide");
	}
};

Info.prototype.__showServices = function() {
	for (var service in kbox.routerinfo.services) {
		var running = (kbox.routerinfo.services[service].running ? "glyphicon-ok" : "glyphicon-remove");
		$("#tr-services").after(
			$('<tr><td>' + kbox.routerinfo.services[service].name +
			  '</td><td><span class="glyphicon '+ running +'"></span></td></tr>')
		);
	}
};

Info.prototype.__showDiskInfos = function() {
	var disk_used = (kbox.routerinfo.disk.space.used != null? kbox.routerinfo.disk.space.used:"-");
	var disk_total = (kbox.routerinfo.disk.space.total != null? kbox.routerinfo.disk.space.total:"-");
	$("#disk_space").text(disk_used + " / " + disk_total);
	$("#disk_temp").text(kbox.routerinfo.disk.temp == null ? "-" : kbox.routerinfo.disk.temp);
};

Info.prototype.__showNetwork = function() {
	try{
	$("#info-lan-ip4").text(kbox.routerinfo.ip_lan == "none" || kbox.routerinfo.ip_lan == null ? "-" : kbox.routerinfo.ip_lan);
	$("#info-lan-ip6").text(kbox.routerinfo.ipv6_lan == "none" || kbox.routerinfo.ipv6_lan == null ? "-" : kbox.routerinfo.ipv6_lan);
	$("#info-wan-ip4").text(kbox.routerinfo.ip_wan == "none" || kbox.routerinfo.ip_wan == null ? "-" : kbox.routerinfo.ip_wan);
	$("#info-wan-ip6").text(kbox.routerinfo.ipv6_wan == "none" || kbox.routerinfo.ipv6_wan == null ? "-" : kbox.routerinfo.ipv6_wan);
	$("#info-link-used").text(kbox.routerinfo.link_used == "none" || kbox.routerinfo.link_used == null ? "-" :
		(kbox.routerinfo.link_used == "main" ? "lien principal" : "lien de secours"));
	}catch(e){}
};

Info.prototype.__showSys = function() {
	try{
	var version = (kbox.routercfg.firmware_version?kbox.routercfg.firmware_version:"-");
	var model = (kbox.routercfg.model?kbox.routercfg.model:"-");
	$("#version").text(model+"_"+version);
	$("#uptime").text(kbox.routerinfo.uptime == "none" ? "-" : kbox.routerinfo.uptime);
	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")){
		$("#memfree").text(kbox.routerinfo.memory + " utilisée");
	} else {
		$("#cpuload").text(kbox.routerinfo.cpu_load);
		$("#memfree").text(kbox.routerinfo.mem.used + " / " + kbox.routerinfo.mem.total);
	}
	}catch(e){}
};

Info.prototype.__showEthPlug = function() {
	if((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850") || (kbox.new_routercfg.model === 'mini-itx')) {
		$("#table-ce-elcon").find('tr').slice(1).remove();
		var nic_list = (kbox.new_routercfg.model === 'mini-itx' ? this.nic_list_miniitx : this.nic_list_elcon)

		for (var nic in nic_list) {
			var list_equip_length = Object.keys(kbox.routerinfo.port[nic_list[nic]].list_equipments).length
			var state = (kbox.routerinfo.port[nic_list[nic]].state == "UP" ? 
						'<td '+(list_equip_length == 0 ? "" : 'rowspan="'+list_equip_length+'"')+'><span class="glyphicon glyphicon-ok"></span></td>' : 
						'<td '+(list_equip_length == 0 ? "" : 'rowspan="'+list_equip_length+'"')+'><span class="glyphicon glyphicon-remove"></span></td>')
			if ((kbox.new_routercfg.model === 'mini-itx') && ((kbox.new_routercfg.failover_enable) || (kbox.new_routercfg.failover_4g_enable)) && (nic_list[nic] === '1'))
				var port = 'Internet (Failover)'
			else
				var port = (nic_list[nic] == 'wan' ? 'Internet' : 'Ethernet ' + nic_list[nic])
			var mode = (kbox.routerinfo.port[nic_list[nic]].mode != null ? kbox.routerinfo.port[nic_list[nic]].mode : '-')
			var mode_warning = '';
			if ((!mode.match('1000')) && (mode != '-') && (kbox.routerinfo.port['wan'].mode.match('1000')))
				mode_warning += " <span style='margin-left: 10px;' title='Veuillez vérifier votre câble et/ou que votre équipement supporte le gigabit.' class='badge badge-warning'>Attention</span>";

			if (list_equip_length == 0) {
				$("#ce-header-elcon").after(
					$('<tr><th>'+port+'</th>'+state+'<td>'+mode+mode_warning+'</td>'+ 
						'<td> - </td><td> - </td><td> - </td><td> - </td>')
				);
			} else {
				var i = 0;
				var content = "";

				for (var etherdev in kbox.routerinfo.port[nic_list[nic]].list_equipments) {
					var ipv4 = (kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].ip == "none"
								|| kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].ip == null
								? "-" : kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].ip)
					var ipv6 = (kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].ipv6 == "none"
								|| kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].ipv6 == null
								? "-" : kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].ipv6)
					var mac = kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].mac_addr

					var name = ""
					var stlist = kbox.new_routercfg.lan_static_ip;
					for (var st in stlist) {
						if (mac == stlist[st].mac.toLowerCase()) {
							name = stlist[st].description;
							break;
						}
					}

					if (name == "")
						name = (kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].name == "none" 
								|| kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].name == null ?
								"Inconnu" : kbox.routerinfo.port[nic_list[nic]].list_equipments[etherdev].name)

					var mac_oui = mac.toUpperCase().substring(0, 8);
					if (mac_oui == '00:26:AA' || mac_oui == '14:C0:89') {
						mode_warning = ''; // Don't display warning
						name += ' (Dune)';
					}
					else if (mac_oui == 'FC:D5:D9') {
						mode_warning = ''; // Don't display warning
						name += ' (Pure)';
					}

					if (i === 0)
						if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850"))
							content += '<tr><th '+(list_equip_length == 0 ? "" : 'rowspan="'+list_equip_length+'"')+'>'+port+'</th>'+state+
							'<td '+(list_equip_length == 0 ? "" : 'rowspan="'+list_equip_length+'"')+'>'+mode+mode_warning+'</td><td>'+name+'</td><td>'+mac+
							'</td><td>'+ipv4+'</td><td>'+ipv6+'</td></tr>'
						else
							content += '<tr><th '+(list_equip_length == 0 ? "" : 'rowspan="'+list_equip_length+'"')+'>Ethernet '+nic_list[nic]+'</th>'+state+
							'<td '+(list_equip_length == 0 ? "" : 'rowspan="'+list_equip_length+'"')+'>'+mode+mode_warning+'</td><td>'+name+'</td><td>'+mac+
							'</td><td>'+ipv4+'</td><td>'+ipv6+'</td></tr>'
					else
						content += '<tr><td>'+name+'</td><td>'+mac+'</td><td>'+ipv4+'</td><td>'+ipv6+'</td></tr>'
					i += 1
				}

				$("#ce-header-elcon").after($(content));
			}
		}
	} else {
		for (var nic in this.nic_list_netgear) {
			if (kbox.routerinfo[this.nic_list_netgear[nic]].state == "UP"){
				$("#state-"+this.nic_list_netgear[nic]).addClass("glyphicon-ok");
				$("#mode-"+this.nic_list_netgear[nic]).text( $.pclean(kbox.routerinfo[this.nic_list_netgear[nic]].mode) );
				$("#mac-"+this.nic_list_netgear[nic]).text( $.pclean(kbox.routerinfo[this.nic_list_netgear[nic]].equipment) );
				$("#name-"+this.nic_list_netgear[nic]).text( $.pclean(kbox.routerinfo[this.nic_list_netgear[nic]].name_equipment) );
				$("#ip-"+this.nic_list_netgear[nic]).text( $.pclean(kbox.routerinfo[this.nic_list_netgear[nic]].ip_equipment) );
				$("#ip6-"+this.nic_list_netgear[nic]).text( $.pclean(kbox.routerinfo[this.nic_list_netgear[nic]].ipv6_equipment) );
				// Check for DUNE:
				for(var pos in kbox.routerinfo["list_dune"]){
					if (kbox.routerinfo["list_dune"][pos] == kbox.routerinfo[this.nic_list_netgear[nic]].equipment &&
						nic != "1"){
						$("#mac-"+this.nic_list_netgear[nic]).parent().addClass("warning");
						$("#mac-"+this.nic_list_netgear[nic]).html($("#mac-"+this.nic_list_netgear[nic]).text() +
						"<span id='#tooltip-'"+nic+"' style='float:right;' data-toggle='tooltip' data-placement='top' title='Cette dune devrait être branchée sur le port Ethernet 1.' class='badge tata'>?</span>");
						$('.tata').tooltip();
					}
				}
			}else{
				$("#state-"+this.nic_list_netgear[nic]).addClass("glyphicon-remove");
				$("#mode-"+this.nic_list_netgear[nic]).text("-");
				$("#mac-"+this.nic_list_netgear[nic]).text("-");
				$("#name-"+this.nic_list_netgear[nic]).text("-");
				$("#ip-"+this.nic_list_netgear[nic]).text("-");
				$("#ip6-"+this.nic_list_netgear[nic]).text("-");
			}
		}
	}
};

Info.prototype.__showUsbPlug = function() {
	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) {
		var usb_used = (kbox.routerinfo["usb"]["used"] != null? kbox.routerinfo["usb"]["used"]:"-");
		var usb_total = (kbox.routerinfo["usb"]["total"] != null? kbox.routerinfo["usb"]["total"]:"-");
		var usb_name = (kbox.routerinfo["usb"]["name"] != null? kbox.routerinfo["usb"]["name"]:"-");
		var usb_connected = (kbox.routerinfo["usb"]["name"] == null ? "glyphicon-remove" : "glyphicon-ok");
		$('#table-ce-elcon').append(
			$('<tr><th rowspan="2" class="tdVAlign">USB</th><td rowspan="2" class="tdVAlign"><span class="glyphicon '+ usb_connected+
			  '"></span></td><td rowspan="2" class="tdVAlign"> - </td><td rowspan="2" class="tdVAlign">'+ usb_name +'</td>'+
			  '<th class="active" colspan="3">Mémoire</th></tr><tr><td colspan="3">'+ usb_used +' / ' + usb_total +'</td></tr>'
			)
		);
	} else {
		var usb_used = (kbox.routerinfo["usb_used"]?kbox.routerinfo["usb_used"]:"-");
		var usb_total = (kbox.routerinfo["usb_total"]?kbox.routerinfo["usb_total"]:"-");
		$("#usb_name").text( $.pclean(kbox.routerinfo["usb_name"]) );
		$("#usb_state").addClass( ($.pclean(kbox.routerinfo["usb_name"]) == "-" ? "glyphicon-remove" : "glyphicon-ok") );
		$("#usbfree").text(usb_used + " / " + usb_total);
	}
};

Info.prototype.__showWifi = function() {
	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) {
		$(".wifidev").remove();
		$("#tr-wifi").removeClass("toHide");
		$("#tr1-wifi24").removeClass("toHide");
		$("#tr2-wifi24").removeClass("toHide");
		$("#tr1-wifi5").removeClass("toHide");
		$("#tr2-wifi5").removeClass("toHide");

		if (kbox.routerinfo.wireless['2.4Ghz'].status){
			$("#wifi24_status").removeClass("glyphicon-remove");
			$("#wifi24_status").addClass("glyphicon-ok");
		}

		if (kbox.routerinfo.wireless['5Ghz'].status){
			$("#wifi5_status").removeClass("glyphicon-remove");
			$("#wifi5_status").addClass("glyphicon-ok");
		}

		if (kbox.routerinfo.wireless['2.4Ghz'].channel != null)
			$("#wifi24_channel").text(kbox.routerinfo.wireless['2.4Ghz'].channel);

		if (kbox.routerinfo.wireless['5Ghz'].channel != null)
			$("#wifi5_channel").text(kbox.routerinfo.wireless['5Ghz'].channel);

		for (var wifidev in kbox.routerinfo.wireless.list_equipments) {
			var ipv4 = (kbox.routerinfo.wireless.list_equipments[wifidev].ip == "none" ? "-" : kbox.routerinfo.wireless.list_equipments[wifidev].ip)
			var ipv6 = (kbox.routerinfo.wireless.list_equipments[wifidev].ipv6 == "none" ? "-" : kbox.routerinfo.wireless.list_equipments[wifidev].ipv6)

			var name = "";
			var stlist = kbox.new_routercfg.lan_static_ip;
			for (var st in stlist) {
				if (kbox.routerinfo.wireless.list_equipments[wifidev].mac_addr == stlist[st].mac.toLowerCase()) {
					name = stlist[st].description;
					break;
				}
			}

			if (name == "")
				name = (kbox.routerinfo.wireless.list_equipments[wifidev].name == "none" ? "Inconnu" : kbox.routerinfo.wireless.list_equipments[wifidev].name);

			var quality = parseInt(kbox.routerinfo.wireless.list_equipments[wifidev].signal);
			var imgsrc = "0.png";

			if ($.cmpIcoteraFirm(kbox.routercfg.firmware_version, "16.3")) {
				if (quality > -90 && quality < -70)
					imgsrc = "1.png";
				else if (quality >= -70 && quality < -60)
					imgsrc = "2.png";
				else if (quality >= -60 && quality < -30)
					imgsrc = "3.png";
				else if (quality >= -30)
					imgsrc = "4.png";
                        } else {
				if (quality >= 10 && quality < 25)
					imgsrc = "1.png";
				else if (quality >= 25 && quality < 40)
					imgsrc = "2.png";
				else if (quality >= 40 && quality < 60)
					imgsrc = "3.png";
				else if (quality >= 60)
					imgsrc = "4.png";
			}

			$("#wireless-header-elcon").after(
				$('<tr class="wifidev"><td>' + kbox.routerinfo.wireless.list_equipments[wifidev].type +
					'</td><td>'+name+
					'</td><td>'+kbox.routerinfo.wireless.list_equipments[wifidev].mac_addr+
					'</td><td>'+'<img src="./img/' + imgsrc + '" class="signal-img"/>'+
					'</td><td>'+kbox.routerinfo.wireless.list_equipments[wifidev].rate+
					'</td><td>'+kbox.routerinfo.wireless.list_equipments[wifidev].tx_bytes+ " octets" +
					'</td><td>'+kbox.routerinfo.wireless.list_equipments[wifidev].rx_bytes+ " octets" +
					'</td><td>'+ipv4+'</td><td>'+ipv6+'</td>')
			);			
		}
	} else if (kbox.new_routercfg.model != "mini-itx") {
		$("#tr-wifi").removeClass("toHide");
		$("#tr1-wifi24").removeClass("toHide");
		$("#tr2-wifi24").removeClass("toHide");

		if (Object.keys(kbox.routerinfo.wireless).length != 0){
                        $("#wifi24_status").removeClass("glyphicon-remove");
                        $("#wifi24_status").addClass("glyphicon-ok");
                }

                if (kbox.routerinfo.wireless.channel != null)
                        $("#wifi24_channel").text(kbox.routerinfo.wireless.channel);

		$("#noise").text(kbox.routerinfo.wireless.noise?"[Bruit: " + kbox.routerinfo.wireless.noise + " dBm]":"");
		$("#rate").text(kbox.routerinfo.wireless.rate?"[Débit: " + kbox.routerinfo.wireless.rate + "]":"");
		$(".wifidev").remove();
		for (var wifidev in kbox.routerinfo.wireless.list_equipment) {
			var ipv4 = (kbox.routerinfo.wireless.list_equipment[wifidev].ip == "none" ? "-" : kbox.routerinfo.wireless.list_equipment[wifidev].ip)
			var ipv6 = (kbox.routerinfo.wireless.list_equipment[wifidev].ipv6 == "none" ? "-" : kbox.routerinfo.wireless.list_equipment[wifidev].ipv6)

			var quality = parseInt(kbox.routerinfo.wireless.list_equipment[wifidev].quality);
			var imgsrc = "0.png";
			if (quality >= 10 && quality < 15)
				imgsrc = "1.png";
			else if (quality >= 15 && quality < 25)
				imgsrc = "2.png";
			else if (quality >= 25 && quality < 40)
				imgsrc = "3.png";
			else if (quality >= 40)
				imgsrc = "4.png";


			var name = (kbox.routerinfo.wireless.list_equipment[wifidev].name == "none" ? "Inconnu" : kbox.routerinfo.wireless.list_equipment[wifidev].name);
			$("#wireless-header-netgear").after(
				$('<tr class="wifidev"><td>'+name+
					'</td><td>'+kbox.routerinfo.wireless.list_equipment[wifidev].mac_addr+
					'</td><td>'+kbox.routerinfo.wireless.list_equipment[wifidev].rssi+" dBm"+
					'</td><td>'+'<img src="./img/' + imgsrc + '" class="signal-img"/>'+
					'</td><td>'+kbox.routerinfo.wireless.list_equipment[wifidev].tx+' / '+kbox.routerinfo.wireless.list_equipment[wifidev].rx+
					'</td><td>'+ipv4+
					'</td><td>'+ipv6+'</td>')
			);
		}
	}
};

Info.prototype.__showAllEquipments = function() {
	var listAllEquipments = '<table class="table table-bordered table-center"><tr class="active"><th>Nom de l\'équipement</th><th>MAC</th><th>IPv4</th><th>IPv6</th></tr>'
	var equipments = "";
	for(var pos in kbox.routerinfo.all_equipments){
		var mac = kbox.routerinfo.all_equipments[pos].equipment;
		var ipv4 = (kbox.routerinfo.all_equipments[pos].ip_equipment == "none" ? "-" : kbox.routerinfo.all_equipments[pos].ip_equipment);
		var ipv6 = (kbox.routerinfo.all_equipments[pos].ipv6_equipment == "none" ? "-" : kbox.routerinfo.all_equipments[pos].ipv6_equipment);
		var name = (kbox.routerinfo.all_equipments[pos].name_equipment == "none" ? "Nom d'équipement inconnu" : kbox.routerinfo.all_equipments[pos].name_equipment);

		equipments += "<tr><td>" + name + "</td><td>" + mac + "</td><td>" + ipv4 + "</td><td>" + ipv6 + "</td></tr>";
	}
	if (equipments == "")
		equipments = "<tr><td colspan='4'>Aucun équipement trouvé</td></tr>";
		
	listAllEquipments += equipments + "</table";
	$("#content-list").html(listAllEquipments);
}

Info.prototype.__showPhones = function() {
	for (var pos in kbox.routerinfo.voip){
		$("#num-"+pos).text(kbox.routerinfo.voip[pos].username);
		if (kbox.routerinfo.voip[pos].registred) {
			$("#registed-"+pos).removeClass("glyphicon-remove");
			$("#registed-"+pos).addClass("glyphicon-ok");
			for (var pos2 in kbox.routercfg.voipSI) {
				if ((kbox.routerinfo.voip[pos].username == kbox.routercfg.voipSI[pos2].authname) && (kbox.routercfg.voipSI[pos2].proxy != kbox.routerinfo.voip[pos].proxy))
					$("#registed-"+pos).html("<span style='margin-left: 10px;' title='Cette ligne devrait être enregistrée sur "+kbox.routerinfo.voip[pos].proxy+" mais elle est actuellement enregistrée sur "+kbox.routercfg.voipSI[pos2].proxy+". Veuillez redémarrer votre équipement ou contacter votre support.' class='badge badge-warning'>Attention</span>");
			}
		}
	}
};

Info.prototype.onEvent = function() {
	$("body").off();
	var me = this;
	$("body").on("click", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "but-all-equip":
				me.__showAllEquipments();
				$("#list_equipments").modal("show");
				break;
		}
	});
};
