function Lan(){

}

Lan.prototype.rollBack = function() {
	$("#subnet-change-alert").hide();
	$(".save-alert").hide();
    $("#dhcp-entry-ip").val('');
    $("#dhcp-entry-mac").val('');
    $("#dhcp-static-name").val('');
    if (!kbox.new_routercfg["dhcpd_dmdns"]){
      $("#wan_dns_1").val('');
      $("#wan_dns_2").val('');
    }
    this.update();
};

Lan.prototype.__updateDNS = function() {
	if ((kbox.new_routercfg.wan_dns_1) && (kbox.new_routercfg.wan_dns_2)){
		$("#wan_dns_1").val(kbox.new_routercfg.wan_dns_1);
		$("#wan_dns_2").val(kbox.new_routercfg.wan_dns_2);
	}
};

Lan.prototype.__updateDHCP = function() {
	if (kbox.new_routercfg.dhcpd_dmdns == false) {
		$("#dhcpd_dmdns").prop('checked', false);
		$("#dns-detail").show();
	} else {
		$("#dhcpd_dmdns").prop('checked', true);
		$("#dns-detail").hide();
	}

	((kbox.new_routercfg.lan_dhcpd_koptions == false)?$("#lan_dhcpd_koptions").prop('checked', false):$("#lan_dhcpd_koptions").prop('checked', true));
};

Lan.prototype.__updateLAN = function() {
	if (kbox.new_routercfg.enable_lan_dhcpd) {
		$("#enable_lan_dhcpd").prop('checked', true);
		$("#dhcp-detail").show();
  		$("#dhcp-static").show();

		$("#lan_dhcpd_startip").val(kbox.new_routercfg.lan_dhcpd_startip);
		$("#lan_dhcpd_endip").val(kbox.new_routercfg.lan_dhcpd_endip);
		$("#lan_dhcpd_lease").val(kbox.new_routercfg.lan_dhcpd_lease);

		if (kbox.routercfg.model == "mini-itx") {
			$("#tr_dhcpd_gateway").removeClass("toHide");
			$("#lan_dhcpd_gateway").val(kbox.new_routercfg.lan_dhcpd_gateway);
			$("#tr-dhcp-options").addClass("toHide");
		}

		var stlist = this.__sortStaticLeases(kbox.new_routercfg.lan_static_ip);
		$(".dhcpd_entry").remove();
		for (var st in stlist) {
			$("#tr-add-entry").before(
  				$('<tr id="'+st+'" class="dhcpd_entry"><td>'+stlist[st].ip+
  					'</td><td>'+stlist[st].mac+
  						'</td><td>'+stlist[st].description+'</td><td><button class="del-entry" type="button" onclick="javascript:instance.removeStatic(\''+st+'\');"><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
			);
		}
		kbox.getLANMac(stlist);
		if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
			if (st == 49)
				$("#tr-add-entry").addClass("toHide");
			else
				$("#tr-add-entry").removeClass("toHide");
		}

		if (kbox.routercfg.model == "mini-itx") {
			if (kbox.new_routercfg.lan_ip != kbox.new_routercfg.lan_dhcpd_gateway)
				$("#alert_lan_gateway").removeClass("toHide");
			else
				$("#alert_lan_gateway").addClass("toHide");
		}
	}
	else {
  		$("#dhcp-static").hide();
		$("#enable_lan_dhcpd").prop('checked', false);
		$("#dhcp-detail").hide();
	}
};

Lan.prototype.update = function() {
	$("#dhcp-entry-ip").attr("placeholder", kbox.subnet);
	kbox.showChange()
	$("#popup-loading").hide();
	$("#lan_ip").val(kbox.new_routercfg.lan_ip);
	$('#dns-label').html("Utiliser les serveurs DNS de " + (!kbox.routercfg.company?'votre FAI':kbox.routercfg.company))
	$('#dhcp-options-label').html("Activer les options DHCP de " + (!kbox.routercfg.company?'votre FAI':kbox.routercfg.company))
	this.__updateDNS();
	this.__updateDHCP();
	this.__updateLAN();	
};

Lan.prototype.updateEvent = function() {
	$(".host-item").off();
	$(".host-item").click(function() {
		$("#dhcp-entry-mac").val($(this).text().substring(0,17));
		kbox.Check.checkmac($("#dhcp-entry-mac"));
	});
};

Lan.prototype.onEvent = function() {
	$("body").off();
	var me = this;

	$('.popover-dismiss').popover({
    	trigger: 'focus'
	});

	$("body").on("change", function(event){
		// ID Element:
		switch(event.target.id){
			case "enable_lan_dhcpd":
				kbox.new_routercfg.enable_lan_dhcpd = !kbox.new_routercfg.enable_lan_dhcpd;
				break;
			case "dhcpd_dmdns":
				kbox.new_routercfg.dhcpd_dmdns = !kbox.new_routercfg.dhcpd_dmdns;
				break;
			case "lan_dhcpd_koptions":
				kbox.new_routercfg.lan_dhcpd_koptions = !kbox.new_routercfg.lan_dhcpd_koptions;
				break;
		}

		// Class element (ip, mac, ...):
		var elem = $("#"+event.target.id);
		if (elem.hasClass("input-change")){
			if (elem.attr('id') == "input-dns1")
				kbox.new_routercfg.wan_dns_1 = elem.value;
			else if (elem.attr('id') == "input-dns2")
	        	kbox.new_routercfg.wan_dns_2 = elem.value;
	      	else if (elem.attr('id') != "dhcp-entry-mac")
	        	kbox.new_routercfg[elem.attr('id')] = (elem.attr('id') == "lan_dhcpd_lease" ? parseInt(elem.val()) : elem.val());
		    var okay = kbox.Check.checktype(elem);
		    if (elem.attr('id') == 'lan_ip' && okay)
		        me.__updateSubnet(elem.val());
		}
        me.update();
	});

	$("#btn-add-entry").click(function() {
	    var ip = $("#dhcp-entry-ip").val();
	    var mac = $("#dhcp-entry-mac").val();
	    var name = $("#dhcp-static-name").val();
	    if (!ip || !mac || !name || $("#tr-add-entry .has-error").length > 0)
	      return;

	    name = name.replace(/>/g, '&gt;').replace(/</g, '&lt;');

	    $("#dhcp-entry-ip").val('');
	    $("#dhcp-entry-ip").parent().removeClass("has-success");
	    $("#dhcp-entry-mac").val('');
	    $("#dhcp-entry-mac").parent().removeClass("has-success");
	    $("#dhcp-static-name").val('');

	    kbox.add_dhcpd_static_entry(ip,mac,name);
	    me.update();
	  });

	$("#dhcp-entry-ip").focus(function() {
		$(this).val(kbox.subnet);
	});

	$("#dhcp-entry-ip").blur(function() {
		if ($(this).val() == kbox.subnet)
			$(this).val("");
	});
};

Lan.prototype.__sortStaticLeases = function(static_leases) {
	return(static_leases.sort(function(first, second) {
		if(kbox.Check.inet_aton(first.ip) < kbox.Check.inet_aton(second.ip)) return -1;
		if(kbox.Check.inet_aton(first.ip) > kbox.Check.inet_aton(second.ip)) return 1;
		return 0;
	}));
};

Lan.prototype.__updateSubnet = function(ip) {
	var new_sub = ip.match(/^.*\./)[0];
	if (new_sub != kbox.subnet) {
		kbox.new_routercfg.lan_dhcpd_startip = kbox.new_routercfg.lan_dhcpd_startip.replace(kbox.subnet, new_sub);
		kbox.new_routercfg.lan_dhcpd_endip = kbox.new_routercfg.lan_dhcpd_endip.replace(kbox.subnet, new_sub);
		if (kbox.routercfg.model == "mini-itx")
			kbox.new_routercfg.lan_dhcpd_gateway = kbox.new_routercfg.lan_dhcpd_gateway.replace(kbox.subnet, new_sub);
		var stlist = this.__sortStaticLeases(kbox.new_routercfg.lan_static_ip);
		for (var st in stlist) {
			kbox.new_routercfg.lan_static_ip[st].ip = stlist[st].ip.replace(kbox.subnet, new_sub);
		}
		$("#subnet-change-alert").show();
		kbox.subnet = new_sub;
	}
};

Lan.prototype.removeStatic = function(id) {
	kbox.remove_dhcpd_static_entry(id);
	$("#"+id).remove();
	instance.update();
};
