function Phone(){
	this.fxs_list = ['2', '1'];
	this.__initLinesInfos()
}

Phone.prototype.rollBack = function() {
	this.update();
};

Phone.prototype.update = function() {
	kbox.showChange();
	if (!kbox.routercfg)
		return;
	if (kbox.sub_id)
		$("#phone-configuration").hide();
	else
		this.__checkMigrated();
	this.__checkLinesInfos();
};

Phone.prototype.onEvent = function() {
	var me = this;
	$("body").off();
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "phone1_active":
				kbox.new_routercfg.voip[1].enable = !kbox.new_routercfg.voip[1].enable;
				me.__updatePhone($("#phone1_authname"), 1);
				break;
			case "phone2_active":
				kbox.new_routercfg.voip[2].enable = !kbox.new_routercfg.voip[2].enable;
				me.__updatePhone($("#phone2_authname"), 2);
				break;
			case "phone1_authname":
				me.__updatePhone(elem, 1);
				break;
			case "phone2_authname":
				me.__updatePhone(elem, 2);
				break;
		}
		me.update();
	});

	 $("body").on("click", function(event){
                switch(event.target.id){
                        case "run-phone-reset":
                                kbox.phoneReset();
                                break;
                }
        })
};

Phone.prototype.__checkMigrated = function() {
	if (Object.keys(kbox.new_routercfg.voipSI).length == 0) {
		$("#phone-configuration").hide();
	} else {
		for(var id in kbox.new_routercfg.voipSI) {
			if (kbox.new_routercfg.voipSI[id].migrated)
				$("#phone-configuration").hide();
			else
				$("#phone-configuration").show();
		}
	}
}

Phone.prototype.__updatePhone = function(elem, phoneID) {
	kbox.new_routercfg.voip[phoneID].authname = elem.val()
	for(var id in kbox.new_routercfg.voipSI) {
		if (kbox.new_routercfg.voipSI[id].authname == kbox.new_routercfg.voip[phoneID].authname) {
			kbox.new_routercfg.voip[phoneID].authpassword = kbox.new_routercfg.voipSI[id].authpassword;
			kbox.new_routercfg.voip[phoneID].proxy = kbox.new_routercfg.voipSI[id].proxy;
		}
	}
}

Phone.prototype.__checkLinesInfos = function() {
	for (var id in this.fxs_list) {
		if (kbox.new_routercfg.voip[this.fxs_list[id]].enable == true){
			$("#phone"+this.fxs_list[id]+"_active").prop("checked", true);
			$("#phone"+this.fxs_list[id]+"_authname").prop("disabled", false);
			$("#phone"+this.fxs_list[id]+"_infos").prop("disabled", false);
		} else {
			$("#phone"+this.fxs_list[id]+"_active").prop("checked", false);
			$("#phone"+this.fxs_list[id]+"_authname").prop("disabled", true);
			$("#phone"+this.fxs_list[id]+"_infos").prop("disabled", true);
		}

		$('#phone'+this.fxs_list[id]+'_authname option[value="'+kbox.new_routercfg.voip[this.fxs_list[id]].authname+'"]').prop('selected', true);
		var mdpSIP = (kbox.new_routercfg.voip[this.fxs_list[id]].proxy != 'b.phone.kwaoo.net' && kbox.new_routercfg.voip[this.fxs_list[id]].proxy != 'c.phone.kwaoo.net'
			      && kbox.new_routercfg.voip[this.fxs_list[id]].proxy != 'd.phone.kwaoo.net' ?
			      '<tr><th>Mot de passe</th><td>'+kbox.new_routercfg.voip[this.fxs_list[id]].authpassword+'</td></tr>' : '');
		var infosPhone = '<table class="table table-bordered table-center"><tr><th>Numéro</th><td>'+kbox.new_routercfg.voip[this.fxs_list[id]].authname+'</td></tr>'+
				 mdpSIP + '<tr><th>Serveur</th><td>'+kbox.new_routercfg.voip[this.fxs_list[id]].proxy+'</td></tr></table>'
		$("#phone"+this.fxs_list[id]+"_infos").attr("data-content", infosPhone);
	}
}

Phone.prototype.__initLinesInfos = function() {
	for (var lineID in kbox.new_routercfg.voipSI) {
		if(kbox.new_routercfg.voipSI[lineID].authname) {
			$("#phone1_authname").append("<option value='"+kbox.new_routercfg.voipSI[lineID].authname+"'>"+kbox.new_routercfg.voipSI[lineID].authname+"</option>")
			$("#phone2_authname").append("<option value='"+kbox.new_routercfg.voipSI[lineID].authname+"'>"+kbox.new_routercfg.voipSI[lineID].authname+"</option>")
		}
	}

	for (var lineID in kbox.new_routercfg.voip) {
		if(kbox.new_routercfg.voip[lineID].authname) {
			for (var lineIDSI in kbox.new_routercfg.voipSI) {
				if(kbox.new_routercfg.voip[lineID].authname === kbox.new_routercfg.voipSI[lineIDSI].authname) {
					if(kbox.new_routercfg.voip[lineID].proxy != kbox.new_routercfg.voipSI[lineIDSI].proxy)
						kbox.new_routercfg.voip[lineID].proxy = kbox.new_routercfg.voipSI[lineIDSI].proxy
					if(kbox.new_routercfg.voip[lineID].authpassword != kbox.new_routercfg.voipSI[lineIDSI].authpassword)
						kbox.new_routercfg.voip[lineID].authpassword = kbox.new_routercfg.voipSI[lineIDSI].authpassword
				}
			}
		}
	}
}
