function Supervision(){
	this.__initVPN();
	this.__initFirewalling();
	this.__initWanSettings();
	this.__initGraph();
	this.__initGraphMonit();
}

Supervision.prototype.__initVPN = function() {
	if (kbox.routercfg.is_vpn_client) {
		$("#li-vpn").removeClass('hide');

		//if customer is not pro or has monit service then vpn is the active
		var active = (kbox.sub_id ? (!kbox.routercfg.rate_graphs) : ((!kbox.routercfg.client_pro) && (!kbox.routercfg.is_monit_client)));
		if (active) {
			$("#li-graphes_conso").removeClass('active');
			$("#graphes_conso").removeClass('active');
			$("#li-vpn").addClass('active');
			$("#vpn").addClass('active');
		}

		kbox.getOpenvpnClient();
	}
}

Supervision.prototype.__initFirewalling = function() {
	if ((kbox.routercfg.is_firewall) && (kbox.routercfg.model === "mini-itx")) {
		$("#li-firewalling").removeClass('hide');
		//if customer is not pro, has no monit service or vpn service then firewall is the active
		var active = (kbox.sub_id ? ((!kbox.routercfg.is_vpn_client) && (!kbox.routercfg.rate_graphs)) : ((!kbox.routercfg.is_monit_client) && (!kbox.routercfg.is_vpn_client) && (!kbox.routercfg.client_pro)));
		if (active){
			$("#li-graphes_conso").removeClass('active');
			$("#graphes_conso").removeClass('active');
			$("#li-firewalling").addClass('active');
			$("#firewalling").addClass('active');
		}
	}
}

Supervision.prototype.__initWanSettings = function() {
	if ((kbox.routercfg.model === "mini-itx") && ((kbox.routercfg.is_failover) || (kbox.routercfg.is_failover_4g) || (kbox.routercfg.is_antivirus) || (kbox.routercfg.is_acceleration))){
		$("#li-wan-settings").removeClass('hide');
		if (kbox.routercfg.is_failover)
			$("#tr_failover").removeClass('toHide');
		if (kbox.routercfg.is_failover_4g)
			$("#tr_failover_4g").removeClass('toHide');
		if (kbox.routercfg.is_antivirus)
			$("#tr_antivirus").removeClass('toHide');
		if (kbox.routercfg.is_acceleration)
			$("#tr_acceleration").removeClass('toHide');
		//if customer is not pro, has no monit service, firewall or vpn service then wan settings is the active
		var active = (kbox.sub_id ? ((!kbox.routercfg.is_vpn_client) && (!kbox.routercfg.rate_graphs) && (!kbox.routercfg.is_firewall)) : ((!kbox.routercfg.is_monit_client) && (!kbox.routercfg.is_vpn_client) && (!kbox.routercfg.client_pro) && (!kbox.routercfg.is_firewall)));
		if (active){
			$("#li-graphes_conso").removeClass('active');
			$("#graphes_conso").removeClass('active');
			$("#li-wan-settings").addClass('active');
			$("#wan_settings").addClass('active');
		}
	}
}

Supervision.prototype.__initGraph = function() {
	var active = (kbox.sub_id ? kbox.routercfg.rate_graphs : kbox.routercfg.client_pro);
	if (active) {
		$("#li-graphes_conso").removeClass('hide');

		kbox.supervisionGraph("day");
	  	kbox.supervisionGraph("week");
	  	kbox.supervisionGraph("month");
	  	kbox.supervisionGraph("year");
	 }
}

Supervision.prototype.__initGraphMonit = function() {
	if ((kbox.routercfg.monit_graphs) && (kbox.routercfg.model === "mini-itx")) {
		$("#li-graphes_monit").removeClass('hide');

		var services = ['uptime', 'ping_ksup_kwaoo_net', 'ping_ipv4_google_com', 'if_eth0', 'if_eth1', 'if_eth2', 'if_eth3'];
		var times = ['day', 'week']
		for(var service in services) {
			for(var time in times) {
				kbox.getMonitGraph(times[time], services[service]);
			}
		}
	}
}

Supervision.prototype.rollBack = function() {
	this.update();
};

Supervision.prototype.updateEvent = function() {
	var me = this;

	$(".host-item-ip").off();
	$(".host-item-ip").click(function() {
		if($(this).parent().parent().parent().attr('id') == "div-frule-src-ip") {
			$("#frule-src-ip").val($(this).text().split(" (")[0]);
			kbox.Check.checkipv4($("#frule-src-ip"));
		} else {
			$("#frule-dst-ip").val($(this).text().split(" (")[0]);
			kbox.Check.checkipv4($("#frule-dst-ip"));
		}
	});

	$(".host-item").off();
	$(".host-item").click(function() {
		$("#frule-src-mac").val($(this).text().split(" (")[0]);
      	kbox.Check.checkmac($("#frule-src-mac"));
	});

	$(".proto-item").off();
	$(".proto-item").click(function() {
		$("#frule-proto").val($("#firewall_proto option:selected").val());
		if (($("#frule-proto").val() == 'tcp') || ($("#frule-proto").val() == 'udp')) {
			$("#frule-dst-port").prop("disabled", false);
			$("#frule-src-port").prop("disabled", false);
		} else {
			$("#frule-dst-port").prop("disabled", true);
			$("#frule-src-port").prop("disabled", true);
		}
	});
};

Supervision.prototype.update = function() {
	kbox.showChange();
	if (!kbox.routercfg)
		return;

	if (kbox.routercfg.is_vpn_client) {
	 	this.__OpenvpnServer();
	  	this.__OpenvpnClient();
	}

	if ((kbox.routercfg.is_failover) || (kbox.routercfg.is_failover_4g)){
		this.__wanFailover();
		this.__failoverQoS();
	}

	if (kbox.routercfg.is_antivirus)
		this.__antivirus();

	if (kbox.routercfg.is_acceleration)
		this.__acceleration();

	if (kbox.routerinfo)
		kbox.getLANMac(kbox.routerinfo["list_dune"]);
	kbox.getLANIp();

	if ((kbox.new_routercfg.failover_enable) || (kbox.new_routercfg.failover_4g_enable))
		$("#tr_qos_failover").removeClass('toHide');
	else
		$("#tr_qos_failover").addClass('toHide');

	this.__FIREWALL();
};

Supervision.prototype.onEvent = function() {
	var me = this;
	$("body").off();
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "openvpn_client_enable":
				kbox.new_routercfg.openvpn_client_enable = !kbox.new_routercfg.openvpn_client_enable;
				break;
			case "openvpn_server_enable":
				kbox.new_routercfg.openvpn_server_enable = !kbox.new_routercfg.openvpn_server_enable;
				break;
			case "openvpn_server_redirect":
				kbox.new_routercfg.openvpn_server_redirect = !kbox.new_routercfg.openvpn_server_redirect;
				break;
			case "failover_enable":
				kbox.new_routercfg.failover_enable = !kbox.new_routercfg.failover_enable;
				break;
			case "failover_4g_enable":
				kbox.new_routercfg.failover_4g_enable = !kbox.new_routercfg.failover_4g_enable;
				break;
			case "qos_failover_enable":
				kbox.new_routercfg.qos_failover_enable = !kbox.new_routercfg.qos_failover_enable;
				break;
			case "antivirus_enable":
				kbox.new_routercfg.antivirus_enable = !kbox.new_routercfg.antivirus_enable;
				break;
			case "acceleration_enable":
				kbox.new_routercfg.acceleration_enable = !kbox.new_routercfg.acceleration_enable;
				break;
			case "frule-src-mac":
				kbox.Check.checkmac(elem);
				break;
			case "vpn_client_addr":
				kbox.Check.checklistip(elem);
				break;
			case "frule-src-ip":
			case "frule-dst-ip":
				me.__checkSrcDstIP(elem);
		}

		if (elem.hasClass("input-change"))
			me.__checkForInput(elem);
		else if (elem.hasClass("port-check"))
			me.__checkPort(elem);
		else if (elem.hasClass("select-change"))
			kbox.new_routercfg[event.target.id] = event.target.value;

		if (event.target.id == "frule-name" || event.target.id == "frule-src-ip" ||
			event.target.id == "frule-dst-ip" || event.target.id == "frule-src-port" ||
			event.target.id == "frule-dst-port" || event.target.id == "phone_number" ||
			event.target.id == "frule-target" || event.target.id == "firewall_proto" ||
			event.target.id == "frule-active" || event.target.id == "frule-src-mac")
			return;
		me.update();
	});

	$("body").on("click", function(event){
		switch(event.target.id){
	    	case "add-vpn-button":
	    		me.addVPNClient();
	    		break;
	    	case "btn-add-firewall-rule":
	    		me.__addFirewallRule();
	    		me.update();
		}
	});
};

Supervision.prototype.__wanFailover = function() {
	if (kbox.new_routercfg.failover_enable == true) {
		$("#failover_enable").prop("checked", true);
		$("#failover_4g_enable").prop("disabled", true);
	} else {
		$("#failover_enable").prop("checked", false);
		$("#failover_4g_enable").prop("disabled", false);
	}

	if (kbox.new_routercfg.failover_4g_enable == true) {
		$("#failover_4g_enable").prop("checked", true);
		$("#failover_enable").prop("disabled", true);
	} else {
		$("#failover_4g_enable").prop("checked", false);
		$("#failover_enable").prop("disabled", false);
	}
}

Supervision.prototype.__failoverQoS = function() {
	if (kbox.new_routercfg.qos_failover_enable == true)
		$("#qos_failover_enable").prop("checked", true);
	else
		$("#qos_failover_enable").prop("checked", false);
}

Supervision.prototype.__antivirus = function() {
	if (kbox.new_routercfg.antivirus_enable == true)
		$("#antivirus_enable").prop("checked", true);
	else
		$("#antivirus_enable").prop("checked", false);
}

Supervision.prototype.__acceleration = function() {
	if (kbox.new_routercfg.acceleration_enable == true)
		$("#acceleration_enable").prop("checked", true);
	else
		$("#acceleration_enable").prop("checked", false);
}

Supervision.prototype.__OpenvpnServer = function() {
	if (kbox.new_routercfg.openvpn_server_enable){
		$("#openvpn_server_enable").prop("checked", true);
		$("#id_vpnserver_if_type").removeClass("toHide");
		$("#id_vpnserver_custom").removeClass("toHide");
		if (kbox.new_routercfg.vpn_server_if == 'tun')
			$("#id_vpnserver_redirect").removeClass("toHide");
		else
			$("#id_vpnserver_redirect").addClass("toHide");
		$("#vpn_list").removeClass("toHide");
		$("#alert_vpn").removeClass("toHide");
		$('[data-toggle="tooltip"]').tooltip();
		$("#openvpn_client_enable").prop("disabled", true);
		$("#vpn_server_if option[value='"+ kbox.new_routercfg.vpn_server_if+"']").attr("selected",true);
		$("#vpn_server_custom").val(kbox.new_routercfg.vpn_server_custom)
	} else {
		$("#openvpn_server_enable").prop("checked", false);
		$("#id_vpnserver_if_type").addClass("toHide");
		$("#id_vpnserver_custom").addClass("toHide");
		$("#id_vpnserver_redirect").addClass("toHide");
		$("#vpn_list").addClass("toHide");
		$("#alert_vpn").addClass("toHide")
		$("#openvpn_client_enable").prop("disabled", false);
	}

	if (kbox.new_routercfg.openvpn_server_redirect == true)
		$("#openvpn_server_redirect").prop("checked", true);
	else
		$("#openvpn_server_redirect").prop("checked", false);
}

Supervision.prototype.__OpenvpnClient = function() {
	if (kbox.new_routercfg.openvpn_client_enable){
		$("#openvpn_client_enable").prop("checked", true);
		$("#id_vpnclient_if_type").removeClass("toHide");
		$("#tr_vpn_client_ip").removeClass("toHide");
		$("#tr_vpn_client_ca").removeClass("toHide");
		$("#tr_vpn_client_crt").removeClass("toHide");
		$("#tr_vpn_client_key").removeClass("toHide");
		$("#openvpn_server_enable").prop("disabled", true);
		$("#vpn_client_addr").val(kbox.new_routercfg.vpn_client_addr)
		$("#vpn_client_ca").val(kbox.new_routercfg.vpn_client_ca)
		$("#vpn_client_crt").val(kbox.new_routercfg.vpn_client_crt)
		$("#vpn_client_key").val(kbox.new_routercfg.vpn_client_key)
		$("#vpn_client_if option[value='"+ kbox.new_routercfg.vpn_client_if+"']").attr("selected",true);
	} else {
		$("#openvpn_client_enable").prop("checked", false);
		$("#id_vpnclient_if_type").addClass("toHide");
		$("#tr_vpn_client_ip").addClass("toHide");
		$("#tr_vpn_client_ca").addClass("toHide");
		$("#tr_vpn_client_crt").addClass("toHide");
		$("#tr_vpn_client_key").addClass("toHide");
		$("#openvpn_server_enable").prop("disabled", false);
	}
}

Supervision.prototype.changeStateVPNClient = function(id) {
	if ($("#vpn_button_" + id).hasClass("glyphicon-unchecked")) {
		kbox.updateStateVPNClient($("#vpn_name_" + id).text(), 1, id);
	} else {
		kbox.updateStateVPNClient($("#vpn_name_" + id).text(), 0, id);
	}
}

Supervision.prototype.removeVPNClient = function(id) {
	kbox.deleteVPNClient($("#vpn_name_" + id).text(), id);
}

Supervision.prototype.addVPNClient = function() {
	kbox.addVPNClient($("#vpn-name").val(), $('#vpn_list tr').length - 2);
}

Supervision.prototype.downloadVPNClient = function(id) {
	kbox.downloadVPNClient($("#vpn_name_" + id).text())
}

Supervision.prototype.__checkForInput = function(elem) {
	if (!elem.hasClass("phone-input"))
		kbox.new_routercfg[elem.attr('id')] = elem.val();
 	kbox.Check.checktype(elem);
 	if (elem.hasClass("phone-input")) {
 		if ((elem.parent().hasClass("has-error")) || (elem.val() == ""))
 			$("#btn-active_sms").prop("disabled", true);
 		else
 			$("#btn-active_sms").prop("disabled", false);
 	}
};

Supervision.prototype.__FIREWALL = function() {
	var lr = kbox.new_routercfg.firewall;
	$('.firewall-rule').remove();
	if (($("#frule-proto").val() == 'tcp') || ($("#frule-proto").val() == 'udp')){
		$("#frule-dst-port").prop("disabled", false);
		$("#frule-src-port").prop("disabled", false);
	} else {
		$("#frule-dst-port").prop("disabled", true);
		$("#frule-src-port").prop("disabled", true);
	}
	for (var rule in lr) {
		htmlactive = "";
		off = ""
		if (lr[rule].active == "1")
			htmlactive = 'checked="checked"';
		else
			off = "off"
		$('#tr-add-rule-firewall').before(
			$('<tr id="'+rule+'" class="firewall-rule '+off+'"><td>'+lr[rule].description+
				'</td><td>'+lr[rule].target+
				'</td><td>'+(lr[rule].proto == "" || lr[rule].proto == undefined ? "all" : lr[rule].proto)+
				'</td><td>'+$.wild(lr[rule].src_ip)+'</td><td>'+$.wild(lr[rule].src_port)+
				'</td><td>'+$.wild(lr[rule].dst_ip)+'</td><td>'+$.wild(lr[rule].dst_port)+'</td><td>'+$.wild(lr[rule].src_mac)+
				'</td><td><input class="check-rule" type="checkbox" '+htmlactive+' onclick="javascript:instance.switchStateRule(\''+rule+'\', $(this));"/>'+
				'</td><td><button class="btn-rule-del" style="width:10px;height:10px;" type="button"'+
				' onclick="javascript:instance.removeFirewallRule(\''+rule+'\');"><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
		);
	}
};

Supervision.prototype.__addFirewallRule = function() {
	var name = $("#frule-name").val();
	var target = $("#frule-target").val();
    var proto = $("#frule-proto").val();
    var src_ip = $("#frule-src-ip").val();
    var src_port = $("#frule-src-port").val();
    var dst_ip = $("#frule-dst-ip").val();
    var dst_port = $("#frule-dst-port").val();
    var src_mac = $("#frule-src-mac").val();
    var active = $("#frule-active").is(':checked');

    if (name == "")
        return;
    if (src_ip == "*")
		src_ip = "";
	if (dst_ip == "*")
		dst_ip = "";
	if (proto == "")
		proto = "all";

	if (!kbox.Check.checkport($("#frule-src-port")) &&
        !kbox.Check.checkport($("#frule-dst-port")) &&
        !((kbox.Check.checksubnet($("#frule-src-ip"))) || (kbox.Check.checkrangeip($("#frule-src-ip"))) || (kbox.Check.checklistip($("#frule-src-ip")))) &&
        !((kbox.Check.checksubnet($("#frule-dst-ip"))) || (kbox.Check.checkrangeip($("#frule-dst-ip"))) || (kbox.Check.checklistip($("#frule-dst-ip")))) &&
        !kbox.Check.checkmac($("#frule-src-mac")))
		return;

	for(var pos in kbox.new_routercfg.firewall){
  		if (name == kbox.new_routercfg.firewall[pos].description){
  			$("#frule-name").parent().addClass("has-error");
  			return;
  		}
  	}

    name = name.replace(/>/g, '&gt;').replace(/</g, '&lt;');
    $("#frule-name").val("");
    $("#frule-src-ip").val("");
    $("#frule-src-port").val("");
    $("#frule-dst-ip").val("");
    $("#frule-dst-port").val("");
    $("#frule-src-mac").val("");
    $("#frule-proto").val("");
    $('#firewall_proto option[value="all"]').prop('selected', true);
    $('#frule-target option[value="DROP"]').prop('selected', true);

    $(".has-error").removeClass('has-error');
	$(".has-success").removeClass('has-success');

    kbox.add_fire_rule(name, target, proto, src_ip, src_port, dst_ip, dst_port, src_mac, active);
};

Supervision.prototype.removeFirewallRule = function(id) {
	if (kbox.new_routercfg.firewall[id])
		kbox.new_routercfg.firewall.splice(id,1);
	this.update();
};

Supervision.prototype.switchStateRule = function(id, elem) {
	kbox.new_routercfg.firewall[id].active = !kbox.new_routercfg.firewall[id].active;
	if (!kbox.new_routercfg.firewall[id].active)	
		elem.removeClass("off");
	else
		elem.addClass("off");
	this.update();
};


Supervision.prototype.__checkPort = function(elem) {
	if (elem.val() == "") {
		elem.parent().removeClass("has-error");
		elem.parent().removeClass("has-success");
	}
	else if (kbox.Check.checkport(elem)) {
		elem.parent().removeClass("has-error");
		elem.parent().addClass("has-success");
	}
	else {
		elem.parent().removeClass("has-success");
		elem.parent().addClass("has-error");
	}
};

Supervision.prototype.__checkSrcDstIP = function(elem) {
  	var okay = ((kbox.Check.checksubnet(elem)) || (kbox.Check.checkrangeip(elem)) || (kbox.Check.checklistip(elem)));
	if (elem.val() == "") {
    	elem.parent().removeClass("has-error");
    	elem.parent().removeClass("has-success");
    }
    else if (okay) {
    	elem.parent().removeClass("has-error");
    	elem.parent().addClass("has-success");
    }
    else {
    	elem.parent().removeClass("has-success");
    	elem.parent().addClass("has-error");
    }
};
