function Tools(){
	this.revs = '';
	kbox.getRevs(this.__callbackRevs);
}

Tools.prototype.rollBack = function() {
	this.update();
};

Tools.prototype.update = function() {
	$("#div-wol").removeClass("toHide");

	if ((kbox.routercfg.model === "i4600") || (kbox.routercfg.model === "i4850"))
		$("#div-debug").removeClass("toHide");

	if(kbox.routercfg.is_admin == 1)
		$("#main-conf").removeClass("toHide");

	this.__Portmirror();
	$("#popup-loading").hide();
	kbox.showChange();
	if (kbox.routerinfo)
		kbox.getSTATICMac();
};

Tools.prototype.updateEvent = function() {
	$(".host-item").off();
	$(".host-item").click(function() {
		$("#wol-entry-mac").val($(this).text().substring(0,17));
		kbox.Check.checkmac($("#wol-entry-mac"));
	});
};

Tools.prototype.onEvent = function() {
	var me = this;
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "ping-host":
				kbox.Check.checkping($("#ping-host"));
				break;
			case "portmirror_enable":
				kbox.new_routercfg.portmirror_enable = !kbox.new_routercfg.portmirror_enable;
				break;
			case "wol-entry-mac":
				kbox.Check.checkmac($("#wol-entry-mac"));
				break;
			case "import-conf":
                                kbox.importConf(event);
                                break;
		}

		if (elem.hasClass("select-change"))
			kbox.new_routercfg[event.target.id] = event.target.value;
		me.update();
	});

	$("body").on("click", function(event){
		switch(event.target.id){
			case "btn-reboot-entry":
				$("#btn-reboot-entry").text('En cours...');
        		$("#btn-reboot-entry").prop('disabled', true);
				kbox.manage("reboot");
				break;
			case "btn-reset-entry":
			if (confirm("Voulez-vous réinitialiser votre KBox?"))
      			if (confirm("Voulez-vous VRAIMENT réinitialiser votre KBox?")) {
        			$("#btn-reset-entry").text('En cours...');
        			$("#btn-reset-entry").prop('disabled', true);
					kbox.manage("reset");
				}
				break;
			case "btn-wol":
				kbox.wol($("#wol-entry-mac"));
				break;
			case "btn-ping-host":
				kbox.ping($("#host-ping"));
				break;
			case "btn-traceroute-host":
				kbox.traceroute($("#host-traceroute"));
				break;
			case "check-debug":
				kbox.genDebug();
				break;
			case "run-export-conf":
                                kbox.exportConf();
                                break;
		}
	})
};

Tools.prototype.showRevDiff = function(data) {
	var modifs = "";
	for(var pos in instance.revs){
		if (instance.revs[pos].version == data) {
			for(var pos_diff in instance.revs[pos].diff){
				var del = instance.revs[pos].diff[pos_diff].delete;
				var add = instance.revs[pos].diff[pos_diff].add;
				var change = instance.revs[pos].diff[pos_diff].change;

				if (del)
					modifs += "<li><span style=\"color:red\">" + del + "</span></li>";
				else if (add)
					modifs += "<li><span style=\"color:green\">" + add + "</span></li>";
				else if (change)
					modifs += "<li><span style=\"color:orange\">" + change + "</span></li>";

			}
		}
	}
	if (modifs == "")
		listModifs = "Aucune modification";
	else
		listModifs = "<ul>" + modifs + "<ul>"

	$("#content_list_modifs").html(listModifs);
	$("#list_modifs").modal("show");
};

Tools.prototype.__callbackRevs = function(data) {
	if (data){
		if (Object.keys(data).length === 0) {
			$("#rev-state").text("Aucune révision disponible actuellement");
		} else {
			instance.revs = data;
			$("#table-rev-entry").html("");
			$("#table-rev-entry").append("<tr><th>Date</th><th>Par</th><th>Modifications</th><th>Appliquer</th></tr>");
			for(var pos in data){
				var date = moment(data[pos].date);
				$("#table-rev-entry").append("<tr><td>le "+date.format("DD/MM/YYYY")+" &agrave; "+date.format("HH:mm")+"</td>"+
				"<td>"+data[pos].update_by+"</td><td><button id='show_"+ data[pos].version+"' class='btn-rev-apply' type='button' onclick='javascript:instance.showRevDiff(\""+
				data[pos].version+"\");' title='Voir les modifications'><span class='glyphicon glyphicon-zoom-in'></span></button></td>"+
				"<td><button id='"+ data[pos].version+"' class='btn-rev-apply' type='button' onclick='javascript:kbox.applyRev(\""+
				data[pos].version+"\");' title='Appliquer l&#39;ancienne configuration'><span class='glyphicon glyphicon-floppy-saved'></span></button></td></tr>")
			}
		}
	}else
		$("#rev-state").text("Erreur de chargement des révisions, réessayez plus tard.");
};

Tools.prototype.__Portmirror = function() {
	if ((kbox.new_routercfg.model != "v1") && (kbox.new_routercfg.model != "v2"))
		$("#div-portmirror").removeClass("toHide");

	if (kbox.new_routercfg.model == "mini-itx") {
		$("#portmirror_in option[value='lan 4']").remove();
		$("#portmirror_out option[value='lan 4']").remove();
	}

	if(kbox.new_routercfg.portmirror_enable) {
		$("#portmirror_enable").prop("checked", true);
		$("#tr_portmirror_iface").removeClass("toHide");
		$('#portmirror_in option[value="'+kbox.new_routercfg.portmirror_in+'"]').prop('selected', true);
		$('#portmirror_out option[value="'+kbox.new_routercfg.portmirror_out+'"]').prop('selected', true);
	} else {
		$("#portmirror_enable").prop("checked",false);
		$("#tr_portmirror_iface").addClass("toHide");
	}
};
