function Wifi(){
	this.myBarChart = null;
	this.ctx = null;
	this.data = null;
	this.options = null;
	this.isHidden = true;
	this.json = null;
	this.is5Ghz = false;
	this.generateQRCode();
}

Wifi.prototype.rollBack = function() {
	this.update();
};

Wifi.prototype.updateEvent = function() {
	var me = this;
	$(".host-item").off();
	$(".host-item").click(function() {
		if($(this).parent().parent().parent().attr('id') == "div-btn_5Ghz")
			$("#wifi-restrict-mac_5Ghz").val($(this).text().substring(0,17));
		else
			$("#wifi-restrict-mac").val($(this).text().substring(0,17));
	});
};

Wifi.prototype.update = function() {
	kbox.showChange();

	if (kbox.routercfg.model == "mini-itx") {
		$('#uc_login').text(kbox.routercfg.uc_login);
		$('#uc_passwd').text(kbox.routercfg.uc_passwd);
	} else {
		$("#popup-loading").hide();
		this.set5GhzWireless();
		this.setWireless();
		this.getWirelessMac();
	}
};

Wifi.prototype.onEvent = function() {
	var me = this;
	$("body").off();
	$("body").on("change", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "ssid_24Ghz":
				me.__changeSSID(event.target, "_24Ghz");
				break;
			case "ssid_5Ghz":
				me.__changeSSID(event.target, "_5Ghz");
				break;
			case "wpa_passwd_24Ghz":
				me.__changePWD(elem, "_24Ghz");
				break;
			case "wpa_passwd_5Ghz":
				me.__changePWD(elem, "_5Ghz");
				break;
			case "crypto_24Ghz":
				me.__checkCrypto(elem, "_24Ghz");
				break;
			case "crypto_5Ghz":
				me.__checkCrypto(elem, "_5Ghz");
				break;
		}

		if (elem.hasClass("checkbox-change")){
			kbox.new_routercfg[elem.attr('id')] = !kbox.new_routercfg[elem.attr('id')];
			if ((elem.attr('id') == "enable_24Ghz") || (elem.attr('id') == "enable_5Ghz"))
				me.generateQRCode();
		}
		else if (elem.hasClass("select-change") && kbox.new_routercfg[elem.attr('id')] != elem.val())
			kbox.new_routercfg[elem.attr('id')] = elem.val();
		else if (elem.hasClass("mac-input"))
			kbox.Check.checktype(elem);

		me.update();
	});

	$("body").on("click", function(event){
		var elem = $("#"+event.target.id);
		switch(event.target.id){
			case "scan-input":
			case "scan-wifi":
				me.scanWIFI(false);
      			$("#scan-input").hide();
				break;
			case "myChart":
				// DO NOT DELETE!
				break;
			case "scan-input_5Ghz":
			case "scan-wifi_5Ghz":
				me.scanWIFI(true);
      			$("#scan-input_5Ghz").hide();
				break;
			case "myChart_5Ghz":
				// DO NOT DELETE!
				break;
			case "btn-add-rule":
				me.__addRule("");
				break;
			case "btn-add-rule_5Ghz":
				me.__addRule("_5Ghz");
				break;
			case "btn-add-entry":
				me.__addEntry("");
				break;
			case "btn-add-entry_5Ghz":
				me.__addEntry("_5Ghz");
				break;
			case "run-wps_24Ghz":
                                kbox.runWPS(false);
                                break;
			case "run-wps_5Ghz":
                                kbox.runWPS(true);
                                break;
			case "run-auto-channel_24Ghz":
                                kbox.runAutoChannel(false);
                                break;
			case "run-auto-channel_5Ghz":
                                kbox.runAutoChannel(true);
                                break;
			default:
				$("#myChart").popover("hide");
				me.isHidden = true;
				break
		}

		if (elem.hasClass("btn-mac-restrict"))
			me.__changeMacRestrict(event.target.name, "_24Ghz");
		else if (elem.hasClass("btn-mac-restrict_5Ghz"))
			me.__changeMacRestrict(event.target.name, "_5Ghz");
		else if (event.target.className == "check-wifi-rule")
			me.__swapWifiRule($(event.target));
		else if (elem.hasClass("select-change") && kbox.new_routercfg[elem.attr('id')] != elem.val())
			kbox.new_routercfg[elem.attr('id')] = elem.val();
		me.update();
	});
};

Wifi.prototype.generateQRCode = function() {
	if (kbox.new_routercfg.enable_24Ghz == true) {
		$('#qr-code-24Ghz').empty();
		$('#qr-code-24Ghz').qrcode(
			{
				text:'WIFI:S:'+kbox.new_routercfg.ssid_24Ghz+';T:'+
				(kbox.new_routercfg.security_24Ghz=='wep'?'wep':'WPA')+';P:'+
				(kbox.new_routercfg.security_24Ghz=='wep'?kbox.new_routercfg.wep_passwd_24Ghz:kbox.new_routercfg.wpa_passwd_24Ghz)+';',
				size: 120,
				ecLevel: 'H',
				mode: 2,
				label: 'Wifi 2.4Ghz'
			}
		);
	}

	if (kbox.new_routercfg.enable_5Ghz == true) {
		$('#qr-code-5Ghz').empty();
		$('#qr-code-5Ghz').qrcode(
			{
				text:'WIFI:S:'+kbox.new_routercfg.ssid_5Ghz+';T:'+
				(kbox.new_routercfg.security_5Ghz=='wep'?'wep':'WPA')+';P:'+
				(kbox.new_routercfg.security_5Ghz=='wep'?kbox.new_routercfg.wep_passwd_5Ghz:kbox.new_routercfg.wpa_passwd_5Ghz)+';',
				size: 120,
				ecLevel: 'H',
				mode: 2,
				label: 'Wifi 5Ghz'
			}
		);
	}
};

Wifi.prototype.setWireless = function() {
	if (kbox.new_routercfg.enable_24Ghz == true) {
		$("#enable_24Ghz").prop("checked", true);
		$(".wifi-disabled").show();
		$("#channel-scan").show();

		if (kbox.new_routercfg.model == "i4850")
                        $(".wps-disabled").show();

		if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")){
			if ((kbox.routercfg.channel_24Ghz == 0) && (kbox.new_routercfg.channel_24Ghz == 0))
				$("#div-auto-channel_24Ghz").show();
			else
				$("#div-auto-channel_24Ghz").hide();
		}

		if (kbox.new_routercfg.mode_24Ghz) {
			if (kbox.new_routercfg.mode_24Ghz != 'mixed' && kbox.new_routercfg.mode_24Ghz != 'n-only') {
				$(".bandwith-disabled").hide();
				kbox.new_routercfg.bandwith_24Ghz = '20';
			} else
				$(".bandwith-disabled").show();
			$('#mode_24Ghz option[value="'+kbox.new_routercfg.mode_24Ghz+'"]').prop('selected', true);
		} else
			$('#mode_24Ghz option[value="mixed"]').prop('selected', true);

		if (kbox.new_routercfg.bandwith_24Ghz) {
			if (kbox.new_routercfg.bandwith_24Ghz == '40') {
				$(".elcon-upper").hide();
				$(".netgear-upper").hide();
				this.__check40Mhz();
			} else {
				$(".elcon-upper").show();
				$(".netgear-upper").show();
				$("#warning-40mhz").hide();
			}
			$('#bandwith_24Ghz option[value="'+kbox.new_routercfg.bandwith_24Ghz+'"]').prop('selected', true);
		} else {
			$('#bandwith_24Ghz option[value="20"]').prop('selected', true);
		}

		if (kbox.new_routercfg.channel_24Ghz) {
			if ((kbox.new_routercfg.channel_24Ghz == 0) && (kbox.routerinfo)) {
				if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850"))
					var curr_ap_channel = (kbox.routerinfo.wireless['2.4Ghz'].channel == null ? "inconnu" : kbox.routerinfo.wireless['2.4Ghz'].channel);
				else if ((kbox.routercfg.model == "v1") || (kbox.routercfg.model == "v2"))
					var curr_ap_channel = (kbox.routerinfo.wireless.channel == null ? "inconnu" : kbox.routerinfo.wireless.channel);

				$('#channel_24Ghz option[value="'+kbox.new_routercfg.channel_24Ghz+'"]').html('Auto (Canal actuel: ' + curr_ap_channel + ')');
			} else {
				$('#channel_24Ghz option[value="'+kbox.new_routercfg.channel_24Ghz+'"]').prop('selected', true);
				$('#channel_24Ghz option[value="0"]').html('Auto');
			}
		} else {
			$('#channel_24Ghz option[value="0"]').prop('selected', true);
		}

		if (kbox.new_routercfg.hide_24Ghz == false)
			$("#hide_24Ghz").prop("checked", true);
		else
			$("#hide_24Ghz").prop("checked", false);

		if (kbox.new_routercfg.storm_protection_24Ghz == false)
			$("#storm_protection_24Ghz").prop("checked", false);
		else
			$("#storm_protection_24Ghz").prop("checked", true);

		if (kbox.new_routercfg.wps_24Ghz == false) {
			$("#wps_24Ghz").prop("checked", false);
			$(".run-wps-disabled").hide();
		} else {
			$("#wps_24Ghz").prop("checked", true);
			$(".run-wps-disabled").show();
		}

		$("#ssid_24Ghz").val(kbox.new_routercfg.ssid_24Ghz);

		if (kbox.new_routercfg.security_24Ghz != "disabled") {
			$(".secu-disabled").show();
			$('#security_24Ghz option[value="'+kbox.new_routercfg.security_24Ghz+'"]').prop('selected', true);
			if (kbox.new_routercfg.security_24Ghz == "wep") {
				$("#wep_lenght_24Ghz option[value="+kbox.new_routercfg.wep_lenght_24Ghz+"]").prop('selected', true);	
				$("#crypto_24Ghz").hide();
				$("#wep_lenght_24Ghz").show();
				$("#help_password").text("("+($("#wep_lenght_24Ghz option:selected").val() == "64" ? "5" : "13")+" caractères)");
			}
			else {
				$("#wep_lenght_24Ghz").hide();
				$("#crypto_24Ghz").show();
				$("#help_password").text("(8 ~ 64 caractères)");
			}

			if (kbox.new_routercfg.crypto_24Ghz)
				$('#crypto_24Ghz option[value="'+kbox.new_routercfg.crypto_24Ghz+'"]').prop('selected', true);
			if (kbox.new_routercfg["security_24Ghz"] == "wep"){
				$("#wpa_passwd_24Ghz").val(kbox.new_routercfg.wep_passwd_24Ghz);
						kbox.Check.checkwep($("#wpa_passwd_24Ghz"), ($("#wep_lenght_24Ghz option:selected").val() == "64" ? 5 : 13));
	  			}else{
				$("#wpa_passwd_24Ghz").val(kbox.new_routercfg.wpa_passwd_24Ghz);
	  				kbox.Check.checktype($("#wpa_passwd_24Ghz"));
	  			}
		}
		else {
			$('#security_24Ghz option[value="disabled"]').prop('selected', true);
			$(".secu-disabled").hide();
		}

		this.__setWirelessActivationRange();
		this.__setWirelessACL()
	}
	else {
		$("#enable_24Ghz").prop("checked", false);
		$("#channel-scan").hide();
			$("#table-mac-entry").hide();
		$(".wifi-disabled").hide();
		$(".secu-disabled").hide();
		$(".bandwith-disabled").hide();
		$(".wps-disabled").hide();
	}
}

Wifi.prototype.__check40Mhz = function() {
	if ((kbox.apinfo != null) && (kbox.routerinfo != null) && (kbox.new_routercfg.bandwith_24Ghz == '40')){
		if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850"))
			var curr_ap_channel = (kbox.routerinfo.wireless['2.4Ghz'].channel == null ? "inconnu" : kbox.routerinfo.wireless['2.4Ghz'].channel);
		else if ((kbox.routercfg.model == "v1") || (kbox.routercfg.model == "v2"))
			var curr_ap_channel = (kbox.routerinfo.wireless.channel == null ? "inconnu" : kbox.routerinfo.wireless.channel);

		if (curr_ap_channel == 'inconnu') {
			$("#warning-40mhz").hide();
			return;
		}

		var upper_ap_channel_40mhz = parseInt(curr_ap_channel) + 4;
		var lower_ap_channel_40mhz = parseInt(curr_ap_channel) - 4;
		var upper_ap_channel_20mhz = parseInt(curr_ap_channel) + 2;
		var lower_ap_channel_20mhz = parseInt(curr_ap_channel) - 2;
		var number_ap_40mhz = 0;
		var number_ap_20mhz = 0;

		for(var pos in kbox.apinfo){
			//+2/-2: we assume that an AP use a 20 MHz channel width
			upper_other_ap_channel = parseInt(kbox.apinfo[pos]['Channel']) + 2;
			lower_other_ap_channel = parseInt(kbox.apinfo[pos]['Channel']) - 2;
			if (((lower_other_ap_channel < upper_ap_channel_40mhz) || (upper_other_ap_channel < upper_ap_channel_40mhz)) && ((lower_other_ap_channel > lower_ap_channel_40mhz) || (upper_other_ap_channel > lower_ap_channel_40mhz)))
				++number_ap_40mhz;
			if (((lower_other_ap_channel < upper_ap_channel_20mhz) || (upper_other_ap_channel < upper_ap_channel_20mhz)) && ((lower_other_ap_channel > lower_ap_channel_20mhz) || (upper_other_ap_channel > lower_ap_channel_20mhz)))
				++number_ap_20mhz;
		}

		if (number_ap_40mhz > number_ap_20mhz) {
			$("#warning-40mhz").attr('title','Il y a actuellement, au moins, '+number_ap_40mhz+' points d\'accès utilisant les mêmes canaux que votre point d\'accès. En changeant la largeur de la bande à 20 MHz, il n\'y en aura plus que ' + number_ap_20mhz + '. Par conséquent, si le wifi n\'est pas stable, il serait préférable d\'utiliser une largeur de bande de 20 MHz.');
			$("#warning-40mhz").show();
		} else {
			$("#warning-40mhz").hide();
		}

	} else {
		$("#warning-40mhz").hide();
	}
}

Wifi.prototype.__setWirelessACL = function() {
	$(".btn-mac-restrict").removeClass("btn-primary");
	$(".macmode").hide();
	switch(kbox.new_routercfg.acl_24Ghz) {
	  case "disabled":
	    $("#table-mac-entry").hide();
	    $("#macmode-disabled").show();
	    break;
	  case "allow":
	    $("#table-mac-entry").show();
	    $("#macmode-allow").show();
	    break;
	  case "deny":
	    $("#table-mac-entry").show();
	    $("#macmode-deny").show();
	    break;
	}

	$('.btn-mac-restrict[name="'+kbox.new_routercfg.acl_24Ghz + '"]').addClass("btn-primary");
	$(".wifi-mac-restricted").remove();
	if (kbox.new_routercfg.mac_acl_24Ghz) {
		for (var mac in kbox.new_routercfg.mac_acl_24Ghz) {
			var deviceName = kbox.getDeviceName(kbox.new_routercfg.mac_acl_24Ghz[mac]);
			deviceName = (deviceName == "Inconnu" ? "" : " (" + deviceName + ")");
			$("#tr-add-entry").before(
				$('<tr id="mac-'+mac+'" class="wifi-mac-restricted"><td>'+kbox.new_routercfg.mac_acl_24Ghz[mac]+ deviceName +
					'</td><td><button class="btn-restrict-del" type="button" onclick="javascript:instance.removeEntry(\''+mac+'\', \'mac\', '+false+');"'+
					'><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
			);
		}
	}

	if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
		if (mac == 15)
			$("#tr-add-entry").addClass("toHide");
		else
			$("#tr-add-entry").removeClass("toHide");
	}
}

Wifi.prototype.__setWirelessActivationRange = function() {
	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) {
		$('#rrule_active').html('activé')
		$("#wifi-restrict").show();
	} else {
		$('#rrule_active').html('désactivé')
	}

	$(".wifi-rules").remove();
	for (var rule in kbox.new_routercfg.wifi_acl_timeslot) {
		var htmlactive = "";
		if (kbox.new_routercfg.wifi_acl_timeslot[rule].active == true)
			htmlactive = 'checked="checked"';
		$("#tr-add-rule").before(
			$('<tr id="rule-'+rule+'" class="wifi-rules"><td>'+kbox.new_routercfg.wifi_acl_timeslot[rule].description+
				'</td><td>'+$.days_to_txt(kbox.new_routercfg.wifi_acl_timeslot[rule].days_restrict)+
				'</td><td>'+$.time_to_html(kbox.new_routercfg.wifi_acl_timeslot[rule].begin_restrict)+
				'</td><td>'+$.time_to_html(kbox.new_routercfg.wifi_acl_timeslot[rule].end_restrict)+
				'</td><td><input class="check-wifi-rule" type="checkbox" '+htmlactive+'/>'+
				'</td><td><button class="btn-rule-del" type="button" onclick="javascript:instance.removeEntry(\''+rule+'\', \'rule\','+false+');"'+
				'><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
		);
	}
}

Wifi.prototype.set5GhzWireless = function() {
	if (kbox.new_routercfg.enable_5Ghz == true) {
		$("#enable_5Ghz").prop("checked", true);
		$(".wifi-disabled_5Ghz").show();
		$("#channel-scan_5Ghz").show();

		if (kbox.new_routercfg.model == "i4850")
                        $(".wps-disabled_5Ghz").show();

		if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")){
			if ((kbox.routercfg.channel_5Ghz == 0) && (kbox.new_routercfg.channel_5Ghz == 0))
				$("#div-auto-channel_5Ghz").show();
			else
				$("#div-auto-channel_5Ghz").hide();
		}

		if (kbox.new_routercfg.mode_5Ghz)
			$('#mode_5Ghz option[value="'+kbox.new_routercfg.mode_5Ghz+'"]').prop('selected', true);
		else
			$('#mode_5Ghz option[value="mixed"]').prop('selected', true);

		if (kbox.new_routercfg.channel_5Ghz) {
			if ((kbox.new_routercfg.channel_5Ghz == 0) && (kbox.routerinfo) && ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850"))) {
				var curr_ap_channel = (kbox.routerinfo.wireless['5Ghz'].channel == null ? "inconnu" : kbox.routerinfo.wireless['5Ghz'].channel);
				$('#channel_5Ghz option[value="'+kbox.new_routercfg.channel_5Ghz+'"]').html('Auto (Canal actuel: ' + curr_ap_channel + ')');
			} else {
				$('#channel_5Ghz option[value="'+kbox.new_routercfg.channel_5Ghz+'"]').prop('selected', true);
				$('#channel_5Ghz option[value="0"]').html('Auto');
			}
		} else {
			$('#channel_5Ghz option[value="0"]').prop('selected', true);
		}

		if (kbox.new_routercfg.bandwith_5Ghz)
			$('#bandwith_5Ghz option[value="'+kbox.new_routercfg.bandwith_5Ghz+'"]').prop('selected', true);
		else
			$('#bandwith_5Ghz option[value="40"]').prop('selected', true);

		if (kbox.new_routercfg.hide_5Ghz == false)
			$("#hide_5Ghz").prop("checked", true);
		else
			$("#hide_5Ghz").prop("checked", false);

		if (kbox.new_routercfg.storm_protection_5Ghz == false)
			$("#storm_protection_5Ghz").prop("checked", false);
		else
			$("#storm_protection_5Ghz").prop("checked", true);

		if (kbox.new_routercfg.wps_5Ghz == false) {
			$("#wps_5Ghz").prop("checked", false);
			$(".run-wps-disabled_5Ghz").hide();
		} else {
			$("#wps_5Ghz").prop("checked", true);
			$(".run-wps-disabled_5Ghz").show();
		}

		$("#ssid_5Ghz").val(kbox.new_routercfg.ssid_5Ghz);

		if (kbox.new_routercfg.security_5Ghz != "disabled") {
			$(".secu-disabled_5Ghz").show();
			$('#security_5Ghz option[value="'+kbox.new_routercfg.security_5Ghz+'"]').prop('selected', true);
			if (kbox.new_routercfg.security_5Ghz == "wep") {
				$("#wep_lenght_5Ghz option[value="+kbox.new_routercfg.wep_lenght_5Ghz+"]").prop('selected', true);	
				$("#crypto_5Ghz").hide();
				$("#wep_lenght_5Ghz").show();
				$("#help_password_5Ghz").text("("+($("#wep_lenght_5Ghz option:selected").val() == "64" ? "5" : "13")+" caractères)");
			}
			else {
				$("#wep_lenght_5Ghz").hide();
				$("#crypto_5Ghz").show();
				$("#help_password_5Ghz").text("(8 ~ 64 caractères)");
			}

			if (kbox.new_routercfg.crypto_5Ghz)
				$('#crypto_5Ghz option[value="'+kbox.new_routercfg.crypto_5Ghz+'"]').prop('selected', true);

			if (kbox.new_routercfg["security_5Ghz"] == "wep"){
				$("#wpa_passwd_5Ghz").val(kbox.new_routercfg.wep_passwd_5Ghz);
  					kbox.Check.checkwep($("#wpa_passwd_5Ghz"), ($("#wep_lenght_5Ghz option:selected").val() == "64" ? 5 : 13));
      		}else{
				$("#wpa_passwd_5Ghz").val(kbox.new_routercfg.wpa_passwd_5Ghz);
      			kbox.Check.checktype($("#wpa_passwd_5Ghz"));
      		}
		}
		else {
			$('#security_5Ghz option[value="disabled"]').prop('selected', true);
			$(".secu-disabled_5Ghz").hide();
		}

		this.__set5GhzWirelessActivationRange();
		this.__set5GhzWirelessACL();
	} else {
		$("#enable_5Ghz").prop("checked", false);
		$("#channel-scan_5Ghz").hide();
  		$("#table-mac-entry").hide();
		$(".wifi-disabled_5Ghz").hide();
		$(".secu-disabled_5Ghz").hide();
		$(".wps-disabled_5Ghz").hide();
	}
}

Wifi.prototype.__set5GhzWirelessACL = function() {
	$(".btn-mac-restrict_5Ghz").removeClass("btn-primary");
	$(".macmode_5Ghz").hide();
    switch(kbox.new_routercfg.acl_5Ghz) {
      case "disabled":
        $("#table-mac-entry_5Ghz").hide();
        $("#macmode-disabled_5Ghz").show();
        break;
      case "allow":
        $("#table-mac-entry_5Ghz").show();
        $("#macmode-allow_5Ghz").show();
        break;
      case "deny":
        $("#table-mac-entry_5Ghz").show();
        $("#macmode-deny_5Ghz").show();
        break;
    }

    $('.btn-mac-restrict_5Ghz[name="'+kbox.new_routercfg.acl_5Ghz + '"]').addClass("btn-primary");
    $(".wifi-mac-restricted_5Ghz").remove();
	if (kbox.new_routercfg.mac_acl_5Ghz) {
		for (var mac in kbox.new_routercfg.mac_acl_5Ghz) {
			var deviceName = kbox.getDeviceName(kbox.new_routercfg.mac_acl_5Ghz[mac]);
			deviceName = (deviceName == "Inconnu" ? "" : " (" + deviceName + ")");
			$("#tr-add-entry_5Ghz").before(
				$('<tr id="mac-'+mac+'_5Ghz" class="wifi-mac-restricted_5Ghz"><td>'+kbox.new_routercfg.mac_acl_5Ghz[mac]+ deviceName +
					'</td><td><button class="btn-restrict-del_5Ghz" type="button" onclick="javascript:instance.removeEntry(\''+mac+'\', \'mac\','+true+');"'+
					'><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
			);
		}
	}

	if ((kbox.routercfg.model == "i4600") || (kbox.routercfg.model == "i4850")) {
		if (mac == 15)
			$("#tr-add-entry_5Ghz").addClass("toHide");
		else
			$("#tr-add-entry_5Ghz").removeClass("toHide");
	}
}

Wifi.prototype.__set5GhzWirelessActivationRange = function() {
	if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850")) {
		$('#rrule_active_5Ghz').html('activé')
		$("#wifi-restrict_5Ghz").show();
	} else {
		$('#rrule_active_5Ghz').html('désactivé')
	}

	$(".wifi-rules_5Ghz").remove();
	for (var rule in kbox.new_routercfg.wifi_acl_timeslot_5Ghz) {
		var htmlactive = "";
		if (kbox.new_routercfg.wifi_acl_timeslot_5Ghz[rule].active == true)
			htmlactive = 'checked="checked"';
		$("#tr-add-rule_5Ghz").before(
			$('<tr id="rule-'+rule+'_5Ghz" class="wifi-rules_5Ghz"><td>'+kbox.new_routercfg.wifi_acl_timeslot_5Ghz[rule].description+
				'</td><td>'+$.days_to_txt(kbox.new_routercfg.wifi_acl_timeslot_5Ghz[rule].days_restrict)+
				'</td><td>'+$.time_to_html(kbox.new_routercfg.wifi_acl_timeslot_5Ghz[rule].begin_restrict)+
				'</td><td>'+$.time_to_html(kbox.new_routercfg.wifi_acl_timeslot_5Ghz[rule].end_restrict)+
				'</td><td><input class="check-wifi-rule" type="checkbox" '+htmlactive+'/>'+
				'</td><td><button class="btn-rule-del" type="button" onclick="javascript:instance.removeEntry(\''+rule+'\', \'rule\','+true+');"'+
				'><span class="glyphicon glyphicon-remove"></span></button></td></tr>')
		);
	}
}

Wifi.prototype.getWirelessMac = function() {
	var stlist = [];
	if (kbox.routerinfo && !kbox.getinfo_error){
		var ports = ["1","2","3","4"];
		for(var pos in ports){
			if ((kbox.new_routercfg.model === "i4600") || (kbox.new_routercfg.model === "i4850"))
				for (var etherdev in kbox.routerinfo.port[ports[pos]].list_equipment)
					stlist[stlist.length] = {"mac_address": kbox.routerinfo.port[ports[pos]].list_equipment[etherdev].mac_addr};
			else
				stlist[stlist.length] = {"mac_address": kbox.routerinfo[ports[pos]].equipment};
		}
		for(var pos in kbox.new_routercfg.mac_acl_24Ghz){
			stlist[stlist.length] = {"mac_address":kbox.new_routercfg.mac_acl_24Ghz[pos]};
		}
		kbox.getLANMac(stlist);
	}
	else if (kbox.getinfo_error){
		$("#connected-equipment").html('');
		$("#connected-equipment").append(
			'<li><i>Impossible de joindre la KBox</i> <button onclick="javascript:window.location.reload(true);return false;" class="kbox-refresh btn btn-xs glyphicon glyphicon-refresh"></button></li>'
		);
		return;
	}
}

Wifi.prototype.scanWIFI = function(is5Ghz) {
	if (this.lock_scan)
		return;

	if(is5Ghz) {
		var id_myChart = "myChart_5Ghz";
		var id_scanInfo = "#scan-info_5Ghz";
		var id_scanInfoLoading = "#scan-info-loading_5Ghz";
		var labelChart = ["canal 36", "canal 40", "canal 44", "canal 48"];
	} else {
		var id_myChart = "myChart";
		var id_scanInfo = "#scan-info";
		var id_scanInfoLoading = "#scan-info-loading";
		var labelChart = ["canal 1", "canal 2", "canal 3", "canal 4", "canal 5", "canal 6", "canal 7", "canal 8", "canal 9", "canal 10", "canal 11", "canal 12", "canal 13"];
	}

	$("#" + id_myChart).popover("hide");
	this.isHidden = true;
	this.lock_scan = true;
	$(id_scanInfo).hide();
	$(id_scanInfoLoading).show();
	this.ctx = document.getElementById(id_myChart).getContext("2d");
	this.ctx.canvas.width = 600;
	this.ctx.canvas.height = 400;
	this.options = {
	    scaleBeginAtZero : true,
	    scaleShowGridLines : true,
	    scaleGridLineColor : "rgba(0,0,0,.05)",
	    scaleGridLineWidth : 1,
	    barShowStroke : true,
	    barStrokeWidth : 2,
	    barValueSpacing : 5,
	    barDatasetSpacing : 1,
	    tooltipTemplate: "",
	    title: {
	        display: true,
	        text: 'Répartiton des points d\'accès sur les différents canaux'
        },
		legend: {
			display: false
		},
		scales: {
			yAxes: [{
				ticks: {
					beginAtZero: true,
					callback: function (value) {
						//Ugly patch for IE (isInteger is not defined)
						Number.isInteger = Number.isInteger || function(value) {
						    return typeof value === "number" &&
							   isFinite(value) &&
							   Math.floor(value) === value;
						};
						if (Number.isInteger(value)) { return value; }
					},
					stepSize: 1
				}
			}]
		}
	}
	this.data = {
		labels: labelChart,
		datasets: [
			{
	            label: 'Point(s) d\'accès sur ce canal',
	            backgroundColor: [],
	            data: (is5Ghz ? [0,0,0,0] : [0,0,0,0,0,0,0,0,0,0,0,0,0])
			}
		]
	}
	//////////////////////////
	this.is5Ghz = is5Ghz;
	kbox.scanWIFI(this.__eventWIFI, this, true);
};

Wifi.prototype.__eventWIFI = function(wifiData, error, ctx) {
	if(ctx.is5Ghz) {
		var id_scanInfoLoading = "#scan-info-loading_5Ghz";
		var id_scanInfo = "#scan-info_5Ghz";
	} else {
		var id_scanInfoLoading = "#scan-info-loading";
		var id_scanInfo = "#scan-info";
	}

	if (!error){
		ctx.lock_scan = false;
		$(id_scanInfoLoading).hide();
		$(id_scanInfo).show();
		return;
	}
	ctx.isHidden = false;
	ctx.lock_scan = false;
	$(id_scanInfoLoading).hide();
	try{
		ctx.json = wifiData["data"];
		for(var pos in ctx.json){
			if (ctx.is5Ghz){
				switch (ctx.json[pos].Channel){
					case "36":
						++ctx.data.datasets[0].data[0];
						break;
					case "40":
						++ctx.data.datasets[0].data[1];
						break;
					case "44":
						++ctx.data.datasets[0].data[2];
						break;
					case "48":
						++ctx.data.datasets[0].data[3];
						break;
				}
			}
			else
				++ctx.data.datasets[0].data[parseInt(ctx.json[pos].Channel)-1];
		}
		for (var pos in ctx.data.datasets[0].data) {
			if (ctx.data.datasets[0].data[pos] >= 4)
				ctx.data.datasets[0].backgroundColor.push('rgba(255, 99, 132, 0.2)');
			else if (ctx.data.datasets[0].data[pos] <= 1)
				ctx.data.datasets[0].backgroundColor.push('rgba(75, 192, 192, 0.2)');
			else
				ctx.data.datasets[0].backgroundColor.push('rgba(255, 206, 86, 0.2)');
		}
		ctx.myBarChart = new Chart(ctx.ctx, {
		    type: 'bar',
		    data: ctx.data,
		    options: ctx.options
		});
		ctx.__eventChart(ctx.is5Ghz);
	}catch(e){
		ctx.json = null;
		$(id_scanInfo).show();
	}
};

Wifi.prototype.__eventChart = function(is5Ghz) {
	var id_myChart = (is5Ghz ? "myChart_5Ghz" : "myChart");
	var me = this;
	$("#" + id_myChart).off();
	document.getElementById(id_myChart).onclick = function(evt){
		if (!me.json)
			return;

		var activeBars = me.myBarChart.getElementsAtEvent(evt);
		if (activeBars.length != 0){
			var canal = me.myBarChart.data.labels[activeBars[0]["_index"]].split(" ")[1];
			var listScanWifi = '<table class="table table-bordered table-center"><tr class="active"><th>SSID</th><th>Qualité</th></tr>'
			for (var pos in me.json){
				if (me.json[pos].Channel == canal){
					var quality = parseInt(me.json[pos].Quality);
					var imgsrc = "0.png";
					if (quality >= 10 && quality < 15)
						imgsrc = "1.png";
					else if (quality >= 15 && quality < 25)
						imgsrc = "2.png";
					else if (quality >= 25 && quality < 40)
						imgsrc = "3.png";
					else if (quality >= 40)
						imgsrc = "4.png";
					var ssid = (me.json[pos].SSID).replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;");
					listScanWifi += '<tr><td>'+ssid+'</td><td><img src="./img/'+imgsrc+'" class="signal-img"/></td></tr>'
				}
			}

			listScanWifi += "</table><center><b>"+ me.myBarChart.data.labels[activeBars[0]["_index"]] +"</b></center>"
			$("#" + id_myChart).attr("data-content", listScanWifi);
			if (!me.isHidden)
				$("#" + id_myChart).popover("toggle");
			else
				$("#" + id_myChart).popover("show");
				me.isHidden = false;
		}else{
			$("#" + id_myChart).popover("hide");
			me.isHidden = true;
		}
	};
};

Wifi.prototype.__changeSSID = function(elem, suffix) {
	kbox.new_routercfg[elem.id] = elem.value;
	kbox.Check.checktype($("#ssid" + suffix));
	this.generateQRCode();
};

Wifi.prototype.__changePWD = function(elem, suffix) {
	if (elem.attr('id') == "wpa_passwd" + suffix){
  		kbox.new_routercfg["wpa_passwd" + suffix] = elem.val();
  		kbox.new_routercfg["wep_passwd" + suffix] = elem.val();
  		if (kbox.new_routercfg["security" + suffix] == "wep") {
  			kbox.Check.checkwep(elem, ($("#weg_lenght" + suffix + " option:selected").val() == "64" ? 5 : 13));
  		}
  		else
  			kbox.Check.checktype(elem);
	}
	else
		kbox.Check.checktype(elem);

	this.generateQRCode();
};

Wifi.prototype.__checkCrypto = function(elem, suffix) {
	if ((elem.val() == 'tkip') || (elem.val() == 'tkip+aes'))
		$("#crypto-change-alert" + suffix).show();
	else
		$("#crypto-change-alert" + suffix).hide();
};

Wifi.prototype.__addRule = function(suffix) {
	var is5Ghz = (suffix == "_5Ghz" ? true : false)
	var str = ""+$("#rule-select-days"+suffix).val();
	var adays = eval(str.replace(/\,/g,'+'));
	var begin = $("#rrule_date_begin_h"+suffix).val()*60+parseInt($("#rrule_date_begin_m"+suffix).val());
	var end = $("#rrule_date_end_h"+suffix).val()*60+parseInt($("#rrule_date_end_m"+suffix).val());
	var name = $("#wifi-rule-name"+suffix).val();
	name = name.replace(/>/g, '&gt;').replace(/</g, '&lt;');
	var active = $("#wifi-active-rule"+suffix).is(':checked');

	if (!adays)
		$("#rule-select-days"+suffix).addClass("has-error");
	else
		$("#rule-select-days"+suffix).removeClass("has-error");

	if (!name)
		$("#wifi-rule-name"+suffix).parent().addClass("has-error");
	else
		$("#wifi-rule-name"+suffix).parent().removeClass("has-error");

	if ($("#tr-add-rule"+suffix+" .has-error").length > 0)
		return;
	if (!kbox.wifi_rule_add(name, adays, begin, end, active, is5Ghz))
		$("#wifi-rule-name"+suffix).parent().addClass("has-error");
	else{
		$("#wifi-rule-name"+suffix).parent().removeClass("has-error");
		////////////////////////////
		$("#wifi-rule-name"+suffix).val("");
		$("#wifi-active-rule"+suffix).prop('checked', true);
		$("#rrule_date_begin_h"+suffix+" option[value='0']").attr("selected",true);
		$("#rrule_date_begin_m"+suffix+" option[value='0']").attr("selected",true);
		$("#rrule_date_end_h"+suffix+" option[value='0']").attr("selected",true);
		$("#rrule_date_end_m"+suffix+" option[value='0']").attr("selected",true);
	}
};

Wifi.prototype.__changeMacRestrict = function(value, suffix) {
	if(suffix == "_24Ghz")
		kbox.new_routercfg.acl_24Ghz = value;
	else
		kbox.new_routercfg.acl_5Ghz = value;

	if (value == "allow")
    	$("#btn-lan" + suffix).prop("disabled", false);
    else if (value == "deny")
    	$("#btn-lan" + suffix).prop("disabled", true);
};

Wifi.prototype.__swapWifiRule = function(elem) {
	var id = elem.parent().parent().attr('id');
	kbox.new_routercfg.wifi_acl_timeslot[
	id.substring(5, id.length)
	].active = elem.is(':checked');
};

Wifi.prototype.__addEntry = function(suffix) { 
	var mac = $("#wifi-restrict-mac" + suffix).val();
	if (!mac || !kbox.Check.checktype($("#wifi-restrict-mac" + suffix)))
		return;
	$(".mac-input" + suffix).parent().removeClass("has-success");
	kbox.wifi_restrict_add($("#wifi-restrict-mac" + suffix).val(), suffix == "_5Ghz");
	$("#wifi-restrict-mac" + suffix).val("");
	$("#connected-equipment" + suffix).html("");
	$("#connected-equipment" + suffix).append("<i>Chargement...</i>");
};

Wifi.prototype.removeEntry = function(id, type, is5Ghz) {
	$("#"+type+"-"+id).remove();
	if (type == "mac")
		kbox.wifi_restrict_remove(id, is5Ghz);
	else if (type == "rule")
		kbox.wifi_rule_del(id, is5Ghz);
};
